unit U_ClothContractInPutJY;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxStyles, cxCustomData, cxGraphics, cxFilter, cxData,
  cxDataStorage, cxEdit, DB, cxDBData, cxGridLevel, cxGridCustomTableView,
  cxGridTableView, cxGridDBTableView, cxClasses, cxControls,
  cxGridCustomView, cxGrid, cxMemo, cxRichEdit, ComCtrls, cxContainer,
  cxTextEdit, cxMaskEdit, cxButtonEdit, StdCtrls, ToolWin, DBClient, ADODB,
  ExtCtrls, BtnEdit, cxDropDownEdit;

type
  TfrmClothContractInPutJY = class(TForm)
    ToolBar1: TToolBar;
    TBSave: TToolButton;
    TBClose: TToolButton;
    ScrollBox1: TScrollBox;
    Label1: TLabel;
    ConNo: TEdit;
    Label4: TLabel;
    DLYDate: TDateTimePicker;
    Label5: TLabel;
    ToolBar2: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    cxGrid1: TcxGrid;
    Tv1: TcxGridDBTableView;
    v1PRTSpec: TcxGridDBColumn;
    cxGrid1Level1: TcxGridLevel;
    v1ClothUnit: TcxGridDBColumn;
    ADOTemp: TADOQuery;
    ADOCmd: TADOQuery;
    DataSource1: TDataSource;
    Order_Sub: TClientDataSet;
    DataSource2: TDataSource;
    ADOZDY: TADOQuery;
    CDS_ZDY: TClientDataSet;
    ADOQuery1: TADOQuery;
    v1Column1: TcxGridDBColumn;
    Label2: TLabel;
    QDTime: TDateTimePicker;
    Label3: TLabel;
    Label11: TLabel;
    v1Column2: TcxGridDBColumn;
    Label13: TLabel;
    JYNote: TRichEdit;
    FactoryNoName: TBtnEditA;
    CompanyName: TBtnEditA;
    JYType: TBtnEditA;
    v1Column3: TcxGridDBColumn;
    ConType: TComboBox;
    Label14: TLabel;
    v1Column5: TcxGridDBColumn;
    v1Column6: TcxGridDBColumn;
    v1Column7: TcxGridDBColumn;
    v1Column8: TcxGridDBColumn;
    Label15: TLabel;
    ConTypeOther: TBtnEditA;
    Panel1: TPanel;
    Label30: TLabel;
    Label29: TLabel;
    Label31: TLabel;
    ClothOneQty: TEdit;
    OneQtyUnit: TComboBox;
    MPRTOneQty: TEdit;
    v1Column4: TcxGridDBColumn;
    procedure TBCloseClick(Sender: TObject);
    procedure PRTCodeNameKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure TBSaveClick(Sender: TObject);
    procedure v1OrderUnitPropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v1PRTUnitPropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v1PRTColorPropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure FactoryNoNamePropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v1Column1PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v1PRTMFPropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v1OrderQtyPropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v1ClothQtyPropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v1Column2PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure FactoryNoNamePropertiesChange(Sender: TObject);
    procedure CompanyNamePropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure ConNoKeyPress(Sender: TObject; var Key: Char);
    procedure v1Column3PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure CompanyNameBtnClick(Sender: TObject);
    procedure FactoryNoNameBtnClick(Sender: TObject);
    procedure JYTypeBtnClick(Sender: TObject);
    procedure ConTypeOtherBtnClick(Sender: TObject);
    procedure ConNoExit(Sender: TObject);
    procedure v1Column3PropertiesEditValueChanged(Sender: TObject);
  private
    FXS:Integer;
    procedure InitData();
    procedure ZDYHelp(FButn:TcxButtonEdit;LType:string);
    function  SaveData():Boolean;
    { Private declarations }
  public
    PState,PCopyInt:Integer;
    FMainId,FConNo,FConType:String;

    { Public declarations }
  end;

var
  frmClothContractInPutJY: TfrmClothContractInPutJY;

implementation
uses
  U_DataLink,U_ZDYHelp,U_RTFun,U_GYSList,U_ZDYHelpSel, U_GYSSelList;

{$R *.dfm}

procedure TfrmClothContractInPutJY.TBCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmClothContractInPutJY.InitData();
begin
  with ADOQuery1 do
  begin
    Close;
    SQL.Clear;
    sql.Add(' select * from Contract_Main A inner join Contract_Sub B on A.MainId=B.MainId');
    sql.Add(' where A.MainId='''+Trim(FMainId)+'''');
    Open;
  end;
  SCreateCDS20(ADOQuery1,Order_Sub);
  SInitCDSData20(ADOQuery1,Order_Sub);
  if PCopyInt=1 then
  begin
    FMainId:='';
    with Order_Sub do
    begin
      First;
      while not Eof do
      begin
        Edit;
        FieldByName('SubId').Value:='';
        Post;
        Next;
      end;
    end;
  end;
  SCSHDataNew(ADOQuery1,ScrollBox1,0);
  FactoryNoName.TxtCode:=Trim(ADOQuery1.FieldByName('FactoryNo').AsString);
  ConTypeOther.Text:=Trim(ADOQuery1.FieldByName('ConTypeOther').AsString);
  if PState=0 then
  begin
    QDTime.DateTime:=SGetServerDate(ADOTemp);
    DLYDate.DateTime:=QDTime.DateTime;
    QDTime.Checked:=True;
    DLYDate.Checked:=False;
  end;
  with ADOQuery1 do
  begin
    Close;
    sql.Clear;
    sql.Add('select * from JYOrder_Main where OrderNo='''+Trim(ConNo.Text)+'''');
    Open;
  end;
  SCSHDataNew(ADOQuery1,Panel1,2);
end;

procedure TfrmClothContractInPutJY.ZDYHelp(FButn:TcxButtonEdit;LType:string);
var
  FType,ZDYName,FText:String;
begin

  with ADOZDY do
  begin
    Filtered:=False;
    Close;
    SQL.Clear;
    SQL.Add('select RTrim(ZDYNo) ZDYNo,RTrim(ZDYName) ZDYName from KH_ZDY where Type='''+Trim(LType)+'''');
    Open;
  end;
  FText:=Trim(FButn.Text);
  if FText<>'' then
    SDofilter(ADOZDY,' ZDYName like '+QuotedStr('%'+Trim(FText)+'%'))
  else
    SDofilter(ADOZDY,'');
end;

procedure TfrmClothContractInPutJY.PRTCodeNameKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  {if (key=vk_return) or (Key=vk_Down) then
  begin
    if ADOZDY.Active then
      CXGridZDY.SetFocus;
  end; }
end;

procedure TfrmClothContractInPutJY.FormShow(Sender: TObject);
var
  FSJ:String;
begin
  {if Trim(DParameters1)='1' then
  begin
    v1Price.Visible:=False;
    v1ClothQty.Visible:=False;
    v1PRTQty.Visible:=False;
  end else
  begin
    v1Price.Visible:=True;
    v1ClothQty.Visible:=True;
    v1PRTQty.Visible:=True;
  end;  }


  FSJ:='select ZdyName Name,ZdyName Code from KH_Zdy where TYpe=''JGGX''  ';
  SInitComBoxBySql(ADOTemp,ConType,False,Fsj);
  InitData();
  if PCopyInt=1 then
  begin
    FMainId:='';
    FConNo:='';
    ConNo.Text:='';
    with Order_Sub do
    begin
      First;
      while not Eof do
      begin
        Edit;
        FieldByName('SubId').Value:='';
        FieldByName('ConPrice').Value:=Null;
        FieldByName('Price').Value:=Null;
        Post;
        Next;
      end;
    end;
  end;
  if PCopyInt=1 then
  begin
    PState:=0;
  end;
  if Trim(FMainId)<>'' then
  begin
    with ADOTemp do
    begin
      Close;
      sql.Clear;
      sql.Add('select * from JYOrder_Main_MD where ConMainId='''+Trim(FMainId)+'''');
      Open;
    end;
    if ADOTemp.RecordCount>0 then
    begin
      ConNo.ReadOnly:=True;
    end;
  end;
end;

function TfrmClothContractInPutJY.SaveData():Boolean;
var
  maxno,maxSubNo:String;
begin
  try
    Result:=False;
    ADOCmd.Connection.BeginTrans;
    //
    if Trim(FMainId)='' then
    begin
      if GetLSNo(ADOCmd,maxno,'CM','Contract_Main',3,1)=False then
      begin
        ADOCmd.Connection.RollbackTrans;
        Application.MessageBox('ȡͬˮʧ!','ʾ',0);
        Exit;
      end;
    end else
    begin
      maxno:=Trim(FMainId);
    end;
    with ADOCmd do
    begin
      Close;
      sql.Clear;
      SQL.Add('select * from Contract_Main where MainId='''+Trim(FMainId)+'''');
      Open;
    end;
    with ADOCmd do
    begin
      if Trim(FMainId)='' then
      begin
        Append;
      end
      else begin
        Edit;
      end;
      FieldByName('MainId').Value:=Trim(maxno);
      RTSetsavedata(ADOCmd,'Contract_Main',ScrollBox1,0);
      FieldByName('FactoryNo').Value:=Trim(FactoryNoName.TxtCode);
      if Trim(Order_Sub.fieldbyname('SubId').AsString)='' then
      begin
        FieldByName('Filler').Value:=Trim(DName);
      end else
      begin
        FieldByName('Editer').Value:=Trim(DName);
        FieldByName('EditTime').Value:=SGetServerDateTime(ADOTemp);
      end;
      Post;
    end;
    ///ӱ
    with Order_Sub do
    begin
      First;
      while not Eof do
      begin
        if Trim(Order_Sub.fieldbyname('SubId').AsString)='' then
        begin
          if GetLSNo(ADOCmd,maxSubNo,'CS','Contract_Sub',2,1)=False then
          begin
            ADOCmd.Connection.RollbackTrans;
            Application.MessageBox('ɺͬϸˮ쳣','ʾ',0);
            exit;
          end;
        end else
        begin
          maxSubNo:=Trim(Order_Sub.fieldbyname('SubId').AsString);
        end;
        with ADOCmd do
        begin
          Close;
          SQL.Clear;
          sql.Add('select * from Contract_Sub where ');
          sql.Add('  SubId='''+Trim(maxSubNo)+'''');
          Open;
        end;
        with ADOCmd do
        begin
          if Trim(Order_Sub.fieldbyname('SubId').AsString)='' then
            Append
          else
            Edit;
          FieldByName('MainId').Value:=Trim(maxno);
          FieldByName('SubId').Value:=Trim(maxSubNo);
          RTSetSaveDataCDS(ADOCmd,Tv1,Order_Sub,'Contract_Sub',0);
          Post;
        end;
        Order_Sub.Edit;
        Order_Sub.FieldByName('SubId').Value:=Trim(maxSubNo);
        Next;
      end;
    end;
    ADOCmd.Connection.CommitTrans;
    FMainId:=Trim(maxno);
    Result:=True;
  except
    Result:=False;
    ADOCmd.Connection.RollbackTrans;
    Application.MessageBox('ʧܣ','ʾ',0);
  end;
end;

procedure TfrmClothContractInPutJY.TBSaveClick(Sender: TObject);
begin
  DLYDate.SetFocus;
  if Trim(ConNo.Text)='' then
  begin
    Application.MessageBox('ͬŲΪգ','ʾ',0);
    Exit;
  end;
  if Trim(ConType.Text)='' then
  begin
    Application.MessageBox('ͬͲΪգ','ʾ',0);
    Exit;
  end;
  if Trim(JYType.Text)='' then
  begin
    Application.MessageBox('ԭΪգ','ʾ',0);
    Exit;
  end;
  if Trim(FactoryNoName.Text)='' then
  begin
    Application.MessageBox('Ӧ̲Ϊգ','ʾ',0);
    Exit;
  end;
  if Order_Sub.IsEmpty then
  begin
    Application.MessageBox('ϸΪգ','ʾ',0);
    exit;
  end;
  if Order_Sub.Locate('C_Qty',null,[]) then
  begin
    Application.MessageBox('Ϊ!','ʾ',0);
    Exit;
  end;
  if Order_Sub.Locate('C_Unit',null,[]) then
  begin
    Application.MessageBox('λΪ!','ʾ',0);
    Exit;
  end;
  if Order_Sub.Locate('C_Spec',null,[]) then
  begin
    Application.MessageBox('ͺŲΪ!','ʾ',0);
    Exit;
  end;
  if Application.MessageBox('ȷҪ','ʾ',32+4)<>IDYES then Exit;
  if SaveData() then
  begin
    Application.MessageBox('ɹ','ʾ',0);
    ModalResult:=1;
  end;

end;

procedure TfrmClothContractInPutJY.v1OrderUnitPropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='OrdUnit';
      flagname:='λ';
      if ShowModal=1 then
      begin
        Self.Order_Sub.Edit;
        Self.Order_Sub.FieldByName('OrderUnit').Value:=Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmClothContractInPutJY.v1PRTUnitPropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='OrdUnit';
      flagname:='λ';
      if ShowModal=1 then
      begin
        Self.Order_Sub.Edit;
        Self.Order_Sub.FieldByName('PRTUnit').Value:=Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmClothContractInPutJY.v1PRTColorPropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='OrdColor';
      flagname:='ɫ';
      if ShowModal=1 then
      begin
        Self.Order_Sub.Edit;
        Self.Order_Sub.FieldByName('PRTColor').Value:=Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmClothContractInPutJY.ToolButton1Click(Sender: TObject);
begin
  CopyAddRow(Tv1,Order_Sub);
  with Order_Sub do
  begin
    Edit;
    FieldByName('SubId').Value:='';
    Post;
  end;
  if Order_Sub.RecordCount=1 then
  begin
    with ADOTemp do
    begin
      Close;
      sql.Clear;
      sql.Add('select * from JYOrder_Main where OrderNo='''+Trim(ConNo.Text)+'''');
      Open;
    end;
    if ADOTemp.IsEmpty=False then
    begin
      with Order_Sub do
      begin
        Edit;
        FieldByName('C_Code').Value:=Trim(ADOTemp.fieldbyname('MPRTCode').AsString)+
                                     Trim(ADOTemp.fieldbyname('MPRTGY').AsString);
        FieldByName('C_CodeName').Value:=Trim(ADOTemp.fieldbyname('MPRTCodeName').AsString);
        FieldByName('C_Spec').Value:=Trim(ADOTemp.fieldbyname('MPRTSpec').AsString);
        FieldByName('JGGY').Value:=Trim(ADOTemp.fieldbyname('MPRTGYHZ').AsString);
        FieldByName('MFQty').Value:=Trim(ADOTemp.fieldbyname('MPRTMF').AsString);
        FieldByName('KZQty').Value:=Trim(ADOTemp.fieldbyname('MPRTKZ').AsString);
        FieldByName('C_CF').Value:=Trim(ADOTemp.fieldbyname('MPRTCF').AsString);
        Post;
      end;
    end;
  end;
end;

procedure TfrmClothContractInPutJY.ToolButton2Click(Sender: TObject);
begin
  if Order_Sub.IsEmpty then Exit;
  if Trim(Order_Sub.fieldbyname('SubId').AsString)<>'' then
  begin
    with ADOTemp do
    begin
      Close;
      sql.Clear;
      sql.Add('select * from JYOrder_Main_MD where COnSubId='''+Trim(Order_Sub.fieldbyname('SubId').AsString)+'''');
      Open;
    end;
    if ADOTemp.IsEmpty=false then
    begin
      Application.MessageBox('Ѿ¼뵥ɾ!','ʾ',0);
      Exit;
    end;
    if Application.MessageBox('ȷҪɾ','ʾ',32+4)<>IDYES then Exit;
    with ADOCmd do
    begin
      Close;
      sql.Clear;
      sql.Add('delete Contract_Sub where SubId='''+Trim(Order_Sub.fieldbyname('SubId').AsString)+'''');
      ExecSQL;
    end;
  end;
  Order_Sub.Delete;
end;

procedure TfrmClothContractInPutJY.FactoryNoNamePropertiesButtonClick(
  Sender: TObject; AButtonIndex: Integer);
begin
  if Trim(FMainId)<>'' then
  begin
    with ADOTemp do
    begin
      Close;
      sql.Clear;
      sql.Add('select * from YF_Money_CR A where exists(');
      sql.Add('select * from ContractSX_Sub_MX B inner join Contract_Sub C on B.SubId=C.SubId ');
      sql.Add(' where C.Mainid='''+Trim(FMainId)+'''');
      sql.Add(' and B.MXID=A.YFTypeId)');
      Open;
    end;
    if ADOTemp.IsEmpty=False then
    begin
      Application.MessageBox('ѾӦ޸ĹӦ!','ʾ',0);
      Exit;
    end;
  end;

  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='Factory';
      flagname:='';
      MainType:='YCLFactory';
      if ShowModal=1 then
      begin
        FXS:=99;
        FactoryNoName.Text:=Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
        FactoryNoName.Hint:=Trim(ClientDataSet1.fieldbyname('ZDYNo').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmClothContractInPutJY.v1Column1PropertiesButtonClick(
  Sender: TObject; AButtonIndex: Integer);
begin
  if Trim(ConType.Text)='' then
  begin
    Application.MessageBox('ͬͲΪ!','ʾ',0);
    Exit;
  end;
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='ClothHT';
      flagname:='Ʒ';
      MainType:=Trim(ConType.Text);
      fnote:=True;
      V1Note.Caption:='';
      if ShowModal=1 then
      begin
        Self.Order_Sub.Edit;
        Self.Order_Sub.FieldByName('C_CodeName').Value:=Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
        Self.Order_Sub.FieldByName('C_Code').Value:=Trim(ClientDataSet1.fieldbyname('note').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmClothContractInPutJY.v1PRTMFPropertiesButtonClick(
  Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='KZ';
      flagname:='صλ';
      if ShowModal=1 then
      begin
        Self.Order_Sub.Edit;
        Self.Order_Sub.FieldByName('KZUnit').Value:=Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmClothContractInPutJY.v1OrderQtyPropertiesButtonClick(
  Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='MF';
      flagname:='ŷλ';
      if ShowModal=1 then
      begin
        Self.Order_Sub.Edit;
        Self.Order_Sub.FieldByName('MFUnit').Value:=Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmClothContractInPutJY.v1ClothQtyPropertiesButtonClick(
  Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='PriceUnit';
      flagname:='Ƽ۵λ';
      if ShowModal=1 then
      begin
        Self.Order_Sub.Edit;
        Self.Order_Sub.FieldByName('PriceUnit').Value:=Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmClothContractInPutJY.v1Column2PropertiesButtonClick(
  Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='OrderUnit';
      flagname:='λ';
      if ShowModal=1 then
      begin
        Self.Order_Sub.Edit;
        Self.Order_Sub.FieldByName('C_Unit').Value:=Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmClothContractInPutJY.FactoryNoNamePropertiesChange(
  Sender: TObject);
begin
  {if FXS=99 then
  begin
    PanZDY.Visible:=False;
    FXS:=0;
    Exit;
  end;
  ZDYHelp(FactoryNoName,'FactoryNo1Name');  }
end;

procedure TfrmClothContractInPutJY.CompanyNamePropertiesButtonClick(
  Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='OrdDefStr2';
      flagname:='跽';
      if ShowModal=1 then
      begin
        FXS:=99;
        CompanyName.Text:=Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmClothContractInPutJY.ConNoKeyPress(Sender: TObject;
  var Key: Char);
begin
  {if Key=#13 then
  begin
    if Trim(ConNo.Text)<>'' then
    begin
      with ADOTemp do
      begin
        Close;
        sql.Clear;
        sql.Add('select Top 1* from JYOrder_Main where OrderNo='''+Trim(ConNo.Text)+'''');
        Open;
      end;
      FactoryNoName.Text:=Trim(ADOTemp.fieldbyname('YCLFactory').AsString);
    end;
  end;  }
end;

procedure TfrmClothContractInPutJY.v1Column3PropertiesButtonClick(
  Sender: TObject; AButtonIndex: Integer);
begin
  if Trim(FMainId)<>'' then
  begin
    with ADOTemp do
    begin
      Close;
      sql.Clear;
      sql.Add('select * from YF_Money_CR A where exists(');
      sql.Add('select * from ContractSX_Sub_MX B inner join Contract_Sub C on B.SubId=C.SubId ');
      sql.Add(' where C.Mainid='''+Trim(FMainId)+'''');
      sql.Add(' and B.MXID=A.YFTypeId)');
      Open;
    end;
    if ADOTemp.IsEmpty=False then
    begin
      Application.MessageBox('ѾӦ޸ĹӦ!','ʾ',0);
      Exit;
    end;
  end;

  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='Factory';
      flagname:='';
      MainType:='YCLFactory';
      if ShowModal=1 then
      begin
        with Order_Sub do
        begin
          Edit;
          FieldByName('FactoryNoName').Value:=Trim(ClientDataSet1.fieldbyname('ZdyName').AsString);
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmClothContractInPutJY.CompanyNameBtnClick(Sender: TObject);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='GSTT';
      flagname:='˾̧ͷ';
      V1ZdyStr1.Visible:=True;
      V1ZdyStr2.Visible:=True;
      V1ZdyStr3.Visible:=True;
      V1ZdyStr4.Visible:=True;
      V1ZdyStr1.Caption:='';
      V1ZdyStr2.Caption:='绰';
      V1ZdyStr3.Caption:='';
      V1ZdyStr4.Caption:='ַ';
      frmZDYHelp.Align:=alClient;
      if ShowModal=1 then
      begin
        CompanyName.Text:=Trim(ClientDataSet1.fieldbyname('ZdyName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmClothContractInPutJY.FactoryNoNameBtnClick(
  Sender: TObject);
begin
  try
    frmGYSSelList:=TfrmGYSSelList.Create(Application);
    with frmGYSSelList do
    begin
      if ShowModal=1 then
      begin
        FactoryNoName.Text:=Trim(frmGYSSelList.Order_Main.fieldbyname('KHNameJC').AsString);
        FactoryNoName.TxtCode:=Trim(frmGYSSelList.Order_Main.fieldbyname('ZKId').AsString);
      end;
    end;
  finally
    frmGYSSelList.Free;
  end;
end;

procedure TfrmClothContractInPutJY.JYTypeBtnClick(Sender: TObject);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='ConJYType';
      flagname:='ͬԭ';
      frmZDYHelp.TBAdd.Visible:=False;
      frmZDYHelp.TBEdit.Visible:=False;
      frmZDYHelp.TBDel.Visible:=False;
      if ShowModal=1 then
      begin
        JYType.Text:=Trim(ClientDataSet1.fieldbyname('ZdyName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmClothContractInPutJY.ConTypeOtherBtnClick(Sender: TObject);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='ConTypeOther';
      flagname:='ɹӹͬ';
      if ShowModal=1 then
      begin
        ConTypeOther.Text:=Trim(frmZDYHelp.ClientDataSet1.fieldbyname('ZdyName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmClothContractInPutJY.ConNoExit(Sender: TObject);
begin
  with ADOQuery1 do
  begin
    Close;
    sql.Clear;
    sql.Add('select * from JYOrder_Main where OrderNo='''+Trim(ConNo.Text)+'''');
    Open;
  end;
  SCSHDataNew(ADOQuery1,Panel1,2);
end;

procedure TfrmClothContractInPutJY.v1Column3PropertiesEditValueChanged(
  Sender: TObject);
var
  mvalue:String;
begin
  mvalue:=TcxTextEdit(Sender).EditingText;
  with Order_Sub do
  begin
    Edit;
    FieldByName('C_Code').Value:=Trim(mvalue);
    Post;
  end;
  with ADOTemp do
  begin
    Close;
    sql.Clear;
    sql.Add('select * from JYOrder_Main where OrderNo='''+Trim(ConNo.Text)+'''');
    Open;
  end;
  if ADOTemp.IsEmpty then
  begin
    with ADOTemp do
    begin
      Close;
      sql.Clear;
      sql.Add('select Top 1* from JYOrder_Main where RTrim(MPRTCode)+RTrim(MPRTGY)='''+Trim(mvalue)+'''');
      sql.Add(' order by FillTime desc');
      Open;
    end;
    if ADOTemp.IsEmpty=False then
    begin
      with Order_Sub do
      begin
        Edit;
        {FieldByName('C_Code').Value:=Trim(ADOTemp.fieldbyname('MPRTCode').AsString)+
                                     Trim(ADOTemp.fieldbyname('MPRTGY').AsString);}
        FieldByName('C_CodeName').Value:=Trim(ADOTemp.fieldbyname('MPRTCodeName').AsString);
        FieldByName('C_Spec').Value:=Trim(ADOTemp.fieldbyname('MPRTSpec').AsString);
        FieldByName('JGGY').Value:=Trim(ADOTemp.fieldbyname('MPRTGYHZ').AsString);
        FieldByName('MFQty').Value:=Trim(ADOTemp.fieldbyname('MPRTMF').AsString);
        FieldByName('KZQty').Value:=Trim(ADOTemp.fieldbyname('MPRTKZ').AsString);
        FieldByName('C_CF').Value:=Trim(ADOTemp.fieldbyname('MPRTCF').AsString);
        Post;
      end;
    end;
  end;
end;

end.
