unit U_ZdyAttInput;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxGraphics, cxCustomData, cxStyles, cxTL, cxMaskEdit, DB, ADODB,
  cxInplaceContainer, cxDBTL, cxControls, cxTLData, ComCtrls, ToolWin,
  StdCtrls, cxFilter, cxData, cxDataStorage, cxEdit, cxDBData, DBClient,
  cxGridCustomTableView, cxGridTableView, cxGridDBTableView, ExtCtrls,
  cxSplitter, cxGridLevel, cxClasses, cxGridCustomView, cxGrid,
  cxGridCustomPopupMenu, cxGridPopupMenu, RM_Dataset, RM_System, RM_Common,
  RM_Class, RM_GridReport, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient, IdFTP,ShellAPI,IniFiles, cxCheckBox, cxCalendar,
  cxButtonEdit, cxTextEdit;

type
  TfrmZdyAttInput = class(TForm)
    ToolBar1: TToolBar;
    TBClose: TToolButton;
    ADOQueryTemp: TADOQuery;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    RM1: TRMGridReport;
    RMDB_Main: TRMDBDataSet;
    cxGrid2: TcxGrid;
    Tv2: TcxGridDBTableView;
    cxGridLevel1: TcxGridLevel;
    cxGridPopupMenu2: TcxGridPopupMenu;
    DS_HZ: TDataSource;
    CDS_HZ: TClientDataSet;
    ToolButton3: TToolButton;
    v2Column6: TcxGridDBColumn;
    v2Column1: TcxGridDBColumn;
    v2Column3: TcxGridDBColumn;
    v2Column4: TcxGridDBColumn;
    v2Column5: TcxGridDBColumn;
    v2Column7: TcxGridDBColumn;
    v2Column8: TcxGridDBColumn;
    v2Column9: TcxGridDBColumn;
    v2Column10: TcxGridDBColumn;
    v2Column11: TcxGridDBColumn;
    v2Column12: TcxGridDBColumn;
    v2DefFlt1: TcxGridDBColumn;
    v2Column2: TcxGridDBColumn;
    v2Column13: TcxGridDBColumn;
    ADOQueryKH: TADOQuery;
    DSKH: TDataSource;
    v2Column14: TcxGridDBColumn;
    v2Column15: TcxGridDBColumn;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure v2Column14PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
  private
    { Private declarations }
    procedure InitGrid();
    function  SaveData():Boolean;

  public
        fkhType:string;
    { Public declarations }
    RKFlag,FCYID:String;

  end;

var
  frmZdyAttInput: TfrmZdyAttInput;

implementation
uses
  U_DataLink,U_Fun,U_ZDYHelp, U_WeiXinHelp;

{$R *.dfm}



procedure TfrmZdyAttInput.InitGrid();
begin
  try

    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Filtered:=False;
      Close;
      SQL.Clear;
      sql.Add(' select * from KH_Zdy_Attachment where ATID='''+Trim(FCYID)+'''');
      Open;
    end;
    SCreateCDS20(ADOQueryMain,CDS_HZ);
    SInitCDSData20(ADOQueryMain,CDS_HZ);
  finally
    ADOQueryMain.EnableControls;
  end;
end;


procedure TfrmZdyAttInput.FormDestroy(Sender: TObject);
begin
  //frmZdyAttInput:=nil;
end;

procedure TfrmZdyAttInput.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //Action:=caFree;
end;

procedure TfrmZdyAttInput.TBCloseClick(Sender: TObject);
begin
  WriteCxGrid('ͻ¼1',Tv2,'ͻԶ');
  Close;
end;
procedure TfrmZdyAttInput.FormShow(Sender: TObject);
begin
  ReadCxGrid('ͻ¼1',Tv2,'ͻԶ');
  InitGrid();
  if Trim(FCYID)='' then
  begin
    CDS_HZ.Append;
    CDS_HZ.Post;
  end;
end;

procedure TfrmZdyAttInput.TBRafreshClick(Sender: TObject);
begin
  InitGrid();
end;

function TfrmZdyAttInput.SaveData():Boolean;
var
  maxId,CRID:String;
  fzdyCode:string;
begin
  try
    ADOQueryCmd.Connection.BeginTrans;
    if Trim(FCYID)='' then
    begin
      if GetLSNo(ADOQueryCmd,maxId,'AT','KH_Zdy_Attachment',4,1)=False then
      begin
        Result:=False;
        ADOQueryCmd.Connection.RollbackTrans;
        Application.MessageBox('ȡʧܣ','ʾ',0);
        Exit;
      end;
      IF trim(fkhType)='㶫ͻ' then
      begin
        if GetLSNo(ADOQueryCmd,fzdyCode,'KH','KH_Zdy_Attachment',4,0)=False then
        begin
          Result:=False;
          ADOQueryCmd.Connection.RollbackTrans;
          Application.MessageBox('ȡʧܣ','ʾ',0);
          Exit;
        end;
      end
      else
      IF trim(fkhType)='ݿͻ' then
      begin
        if GetLSNo(ADOQueryCmd,fzdyCode,'HZ','KH_Zdy_Attachment',4,0)=False then
        begin
          Result:=False;
          ADOQueryCmd.Connection.RollbackTrans;
          Application.MessageBox('ȡʧܣ','ʾ',0);
          Exit;
        end;
      end
      else
      begin
        if GetLSNo(ADOQueryCmd,fzdyCode,'KF','KH_Zdy_Attachment',4,0)=False then
        begin
        Result:=False;
        ADOQueryCmd.Connection.RollbackTrans;
        Application.MessageBox('ȡʧܣ','ʾ',0);
        Exit;
        end;
      end
    end
    else
    begin
      maxId:=Trim(FCYID);
    end;

    with ADOQueryCmd do
    begin
      Close;
      SQL.Clear;
      sql.Add('select * from KH_Zdy_Attachment where ATID='''+Trim(FCYID)+'''');
      Open;
    end;
    with ADOQueryCmd do
    begin
      if Trim(FCYID)='' then
      begin
        Append;
        FieldByName('Filler').Value:=Trim(DName);
        FieldByName('zdyCode').Value:=Trim(fzdyCode);
      end else
      begin
        Edit;
        FieldByName('Editer').Value:=Trim(DName);
        FieldByName('Edittime').Value:=SGetServerDateTime(ADOQueryTemp);
      end;
      FieldByName('ATID').Value:=Trim(maxId);
      FieldByName('ZdyName').Value:=Trim(CDS_HZ.fieldbyname('ZdyName').AsString);
      RTSetSaveDataCDS(ADOQueryCmd,Tv2,CDS_HZ,'',0);
      FieldByName('Type').Value:='KHName';
      FieldByName('khType').Value:=trim(fkhType);
      FieldByName('DefFlt1').Value:=CDS_HZ.fieldbyname('DefFlt1').AsFloat;
      FieldByName('Filler').Value:=Trim(DName);
      Post;
    end;
    with ADOQueryCmd do
    begin
      Close;
      SQL.Clear;
      sql.Add('select * from KH_Zdy where ZdyNo='''+Trim(FCYID)+'''');
      Open;
    end;
    with ADOQueryCmd do
    begin
      if Trim(FCYID)='' then
      begin
        Append;
      end else
      begin
        Edit;
      end;
      FieldByName('ZdyNo').Value:=Trim(maxId);
      FieldByName('ZdyName').Value:=Trim(CDS_HZ.fieldbyname('ZdyName').AsString);
      FieldByName('Type').Value:='KHName';
      FieldByName('MainType').Value:=Trim(CDS_HZ.fieldbyname('DEFstr5').AsString);
      Post;
    end;
    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add('select * from KH_Zdy_Attachment where ZdyName='''+Trim(CDS_HZ.fieldbyname('ZdyName').AsString)+'''');
      sql.Add(' and Type=''KHName'' ');
      sql.Add(' and isnull(khType,'''')='+quotedstr(trim(fkhType)));
      Open;
    end;
    if ADOQueryCmd.RecordCount>1 then
    begin
      ADOQueryCmd.Connection.RollbackTrans;
      Application.MessageBox('ͻظ!','ʾ',0);
      Exit;
    end;
    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add('select * from KH_Zdy_Attachment where ZdyCode='''+Trim(CDS_HZ.fieldbyname('ZdyCode').AsString)+'''');
      sql.Add(' and Type=''KHName'' ');
      Open;
    end;
    if ADOQueryCmd.RecordCount>1 then
    begin
      ADOQueryCmd.Connection.RollbackTrans;
      Application.MessageBox('ظ!','ʾ',0);
      Exit;
    end;
    with CDS_HZ do
    begin
      Edit;
      FieldByName('ATID').Value:=Trim(maxId);
      Post;
    end;
    ADOQueryCmd.Connection.CommitTrans;
    Result:=True;
  except
    Result:=True;
    ADOQueryCmd.Connection.RollbackTrans;
    Application.MessageBox('쳣!','ʾ',0);
  end;
end;

procedure TfrmZdyAttInput.ToolButton3Click(Sender: TObject);
begin

  cxGrid2.SetFocus;
  if Trim(CDS_HZ.FieldByName('ZdyName').AsString)='' then
  begin
    Application.MessageBox('ͻƲΪ!','ʾ',0);
    Exit;
  end;
  if Application.MessageBox('ȷҪ','ʾ',32+4)<>IDYES then Exit;  

  if SaveData() then
  begin
    Application.MessageBox('ɹ!','ʾ',0);
    ModalResult:=1;
  end;
end;


procedure TfrmZdyAttInput.v2Column14PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  frmWeiXinHelp:=TfrmWeiXinHelp.create(self);
  with frmWeiXinHelp do
  begin
    if showmodal=1 then
    begin
      CDS_HZ.Edit;
      CDS_HZ.fieldbyName('weixinID').Value:=trim(CDS_Help.fieldbyName('OPENID').asstring);
      CDS_HZ.fieldbyName('weixinName').Value:=trim(CDS_Help.fieldbyName('NICKNAME').asstring);
      CDS_HZ.Post;
    end;
    free;
  end;
  tv2.Controller.EditingController.ShowEdit();
end;

end.
