unit U_ZdyAttInputPB;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxGraphics, cxCustomData, cxStyles, cxTL, cxMaskEdit, DB, ADODB,
  cxInplaceContainer, cxDBTL, cxControls, cxTLData, ComCtrls, ToolWin, StdCtrls,
  cxFilter, cxData, cxDataStorage, cxEdit, cxDBData, DBClient,
  cxGridCustomTableView, cxGridTableView, cxGridDBTableView, ExtCtrls,
  cxSplitter, cxGridLevel, cxClasses, cxGridCustomView, cxGrid,
  cxGridCustomPopupMenu, cxGridPopupMenu, RM_Dataset, RM_System, RM_Common,
  RM_Class, RM_GridReport, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient, IdFTP, ShellAPI, IniFiles, cxCheckBox, cxCalendar, cxButtonEdit,
  cxTextEdit, cxDropDownEdit, strutils, cxCurrencyEdit, cxLookAndFeels,
  cxLookAndFeelPainters, cxNavigator;

type
  TfrmZdyAttInputPB = class(TForm)
    ToolBar1: TToolBar;
    TBClose: TToolButton;
    ADOQueryTemp: TADOQuery;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    RM1: TRMGridReport;
    RMDB_Main: TRMDBDataSet;
    cxGridPopupMenu2: TcxGridPopupMenu;
    DS_HZ: TDataSource;
    CDS_HZ: TClientDataSet;
    ToolButton3: TToolButton;
    cxGrid2: TcxGrid;
    Tv2: TcxGridDBTableView;
    v2Column6: TcxGridDBColumn;
    v2Column3: TcxGridDBColumn;
    v2Column4: TcxGridDBColumn;
    v2Column5: TcxGridDBColumn;
    v2Column8: TcxGridDBColumn;
    v2Column9: TcxGridDBColumn;
    v2Column7: TcxGridDBColumn;
    v2Column1: TcxGridDBColumn;
    cxGridLevel1: TcxGridLevel;
    v2Column11: TcxGridDBColumn;
    v2defstr9: TcxGridDBColumn;
    v2Column13: TcxGridDBColumn;
    v2Mrate: TcxGridDBColumn;
    v2Column15: TcxGridDBColumn;
    v2Column2: TcxGridDBColumn;
    Tv2Column1: TcxGridDBColumn;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure v2Column6PropertiesEditValueChanged(Sender: TObject);
    procedure v2defstr9PropertiesEditValueChanged(Sender: TObject);
    procedure v2Column5PropertiesEditValueChanged(Sender: TObject);
    procedure Tv2Column1PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure Tv2Column1PropertiesEditValueChanged(Sender: TObject);
  private
    { Private declarations }
    procedure InitGrid();
    function SaveData(): Boolean;
  public
    { Public declarations }
    RKFlag, FCYID: string;
    fkhType: string;
  end;

var
  frmZdyAttInputPB: TfrmZdyAttInputPB;

implementation

uses
  U_DataLink, U_Fun, U_ZDYHelp, U_ZdyAttachCPCX;

{$R *.dfm}

procedure TfrmZdyAttInputPB.InitGrid();
begin
  try
    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Filtered := False;
      Close;
      SQL.Clear;
      sql.Add(' select * from KH_Zdy_Attachment where ATID=''' + Trim(FCYID) + '''');
      Open;
    end;
    SCreateCDS20(ADOQueryMain, CDS_HZ);
    SInitCDSData20(ADOQueryMain, CDS_HZ);
  finally
    ADOQueryMain.EnableControls;
  end;
end;

procedure TfrmZdyAttInputPB.FormDestroy(Sender: TObject);
begin
  frmZdyAttInputPB := nil;
end;

procedure TfrmZdyAttInputPB.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmZdyAttInputPB.TBCloseClick(Sender: TObject);
begin
  WriteCxGrid('Ʒ¼1', Tv2, 'ͻԶ');
  Close;
  ModalResult := 1;
end;

procedure TfrmZdyAttInputPB.FormShow(Sender: TObject);
begin
  ReadCxGrid('Ʒ¼1', Tv2, 'ͻԶ');
  InitGrid();
  if Trim(FCYID) = '' then
  begin
    with CDS_HZ do
    begin
      Edit;
      FieldByName('DEFstr5').Value := '';
//      FieldByName('JgcCode').Value := '';
      Post;
    end;
//    CDS_HZ.Append;
//    CDS_HZ.Post;
  end;
end;

procedure TfrmZdyAttInputPB.TBRafreshClick(Sender: TObject);
begin
  InitGrid();
end;

function TfrmZdyAttInputPB.SaveData(): Boolean;
var
  maxId, CRID: string;
begin
  try
    ADOQueryCmd.Connection.BeginTrans;
    if Trim(FCYID) = '' then
    begin
      if GetLSNo(ADOQueryCmd, maxId, 'AT', 'KH_Zdy_Attachment', 4, 1) = False then
      begin
        Result := False;
        ADOQueryCmd.Connection.RollbackTrans;
        Application.MessageBox('ȡʧܣ', 'ʾ', 0);
        Exit;
      end;
    end
    else
    begin
      maxId := Trim(FCYID);
    end;

    with ADOQueryCmd do
    begin
      Close;
      SQL.Clear;
      sql.Add('select * from KH_Zdy_Attachment where ATID=''' + Trim(FCYID) + '''');
      Open;
    end;
    with ADOQueryCmd do
    begin
      if Trim(FCYID) = '' then
      begin
        Append;
        FieldByName('Filler').Value := Trim(DName);
      end
      else
      begin
        Edit;
        FieldByName('Editer').Value := Trim(DName);
        FieldByName('Edittime').Value := SGetServerDateTime(ADOQueryTemp);
      end;
      FieldByName('ATID').Value := Trim(maxId);

      RTSetSaveDataCDS(ADOQueryCmd, Tv2, CDS_HZ, 'KH_Zdy_Attachment', 0);
      FieldByName('ZdyName').Value := Trim(CDS_HZ.fieldbyname('ZdyName').AsString);
      FieldByName('ZdyCode').Value := Trim(maxId);
      FieldByName('Mrate').Value := CDS_HZ.fieldbyname('Mrate').AsFloat;
      FieldByName('defflt1').Value := CDS_HZ.fieldbyname('defflt1').AsFloat;
      FieldByName('Type').Value := 'CP';
      FieldByName('khType').Value := trim(fkhType);
      FieldByName('Filler').Value := Trim(DName);
      Post;
    end;
    with ADOQueryCmd do
    begin
      Close;
      SQL.Clear;
      sql.Add('select * from KH_Zdy where ZdyNo=''' + Trim(FCYID) + '''');
      Open;
    end;
    with ADOQueryCmd do
    begin
      if Trim(FCYID) = '' then
      begin
        Append;
      end
      else
      begin
        Edit;
      end;
      FieldByName('ZdyNo').Value := Trim(maxId);
      FieldByName('ZdyName').Value := Trim(CDS_HZ.fieldbyname('ZdyName').AsString);
      FieldByName('Type').Value := 'CP';
      FieldByName('MainType').Value := Trim(CDS_HZ.fieldbyname('DEFstr5').AsString);
      Post;
    end;
    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add('select * from KH_Zdy_Attachment where ZdyName=''' + Trim(CDS_HZ.fieldbyname('ZdyName').AsString) + ''' and  DEFstr3=''' + Trim(CDS_HZ.fieldbyname('DEFstr3').AsString) + '''');
      sql.Add(' and Type=''CP'' ');
      Open;
    end;
    if ADOQueryCmd.RecordCount > 1 then
    begin
      ADOQueryCmd.Connection.RollbackTrans;
      Application.MessageBox('ƷŲظ!', 'ʾ', 0);
      Exit;
    end;
    with CDS_HZ do
    begin
      Edit;
      FieldByName('ATID').Value := Trim(maxId);
      Post;
    end;

//    with ADOQueryCmd do
//    begin
//      Close;
//      sql.Clear;
//      sql.Add('select * from KH_Zdy_Attachment where ZdyName=''' + Trim(CDS_HZ.fieldbyname('cphh').AsString) + '''');
//      sql.Add(' and Type=''CP'' ');
//      Open;
//    end;
//    if ADOQueryCmd.RecordCount < 1 then
//    begin
//      with ADOQueryCmd do
//      begin
//        Close;
//        sql.Clear;
//        sql.Add('Update KH_Zdy_Attachment Set CPhh=CPhh+''#'' ');
//        sql.Add(' where ATID=''' + maxId + '''');
//        ExecSQL;
//      end;
//
//    end;

    ADOQueryCmd.Connection.CommitTrans;
    Result := True;
  except
    Result := True;
    ADOQueryCmd.Connection.RollbackTrans;
    Application.MessageBox('쳣!', 'ʾ', 0);
  end;
end;

procedure TfrmZdyAttInputPB.ToolButton3Click(Sender: TObject);
begin
  cxGrid2.SetFocus;
{  if Trim(CDS_HZ.FieldByName('ZdyName').AsString)='' then
  begin
    Application.MessageBox('ӦƲΪ!','ʾ',0);
    Exit;
  end; }
  if Application.MessageBox('ȷҪ', 'ʾ', 32 + 4) <> IDYES then
    Exit;

  if SaveData() then
  begin
    Application.MessageBox('ɹ!', 'ʾ', 0);
//    ModalResult := 1;
  end;
  try
    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Filtered := False;
      Close;
      SQL.Clear;
      sql.Add(' select * from KH_Zdy_Attachment where ATID='' '' ');
      Open;
    end;
    SCreateCDS20(ADOQueryMain, CDS_HZ);
    SInitCDSData20(ADOQueryMain, CDS_HZ);
  finally
    ADOQueryMain.EnableControls;
  end;
  if Trim(FCYID) = '' then
  begin
    with CDS_HZ do
    begin
      Edit;
      FieldByName('DEFstr5').Value := '';
//      FieldByName('JgcCode').Value := '';
      Post;
    end;
//    CDS_HZ.Append;
//    CDS_HZ.Post;
  end;
end;

procedure TfrmZdyAttInputPB.v2Column6PropertiesEditValueChanged(Sender: TObject);
var
  mvalue: string;
begin
  mvalue := TcxTextEdit(Sender).EditingText;

  if trim(mvalue) = '' then
    exit;

  if rightBstr(trim(mvalue), 1) <> '#' then
  begin
    mvalue := trim(mvalue) + '#';
  end;

  with CDS_HZ do
  begin
    Edit;
    FieldByName('ZdyName').Value := Trim(mvalue);
    Post;
  end;
  self.tv2.Controller.EditingController.ShowEdit();

end;

procedure TfrmZdyAttInputPB.v2defstr9PropertiesEditValueChanged(Sender: TObject);
var
  mvalue: string;
begin
  mvalue := TcxTextEdit(Sender).EditingText;

  if trim(mvalue) = '' then
    exit;

  if rightBstr(trim(mvalue), 1) <> '#' then
  begin
    mvalue := trim(mvalue) + '#';
  end;

  with CDS_HZ do
  begin
    Edit;
    FieldByName('ZdyName').Value := Trim(mvalue);
    Post;
  end;
  self.tv2.Controller.EditingController.ShowEdit();

end;

procedure TfrmZdyAttInputPB.v2Column5PropertiesEditValueChanged(Sender: TObject);
var
  mvalue: string;
begin
  mvalue := TcxTextEdit(Sender).EditingText;

  if trim(mvalue) = '' then
    exit;

  if rightBstr(trim(mvalue), 1) <> '#' then
  begin
    mvalue := trim(mvalue) + '#';
  end;

  with CDS_HZ do
  begin
    Edit;
    FieldByName('DEFstr3').Value := Trim(mvalue);
    Post;
  end;
  self.tv2.Controller.EditingController.ShowEdit();

end;

procedure TfrmZdyAttInputPB.Tv2Column1PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmZdyAttachCPCX := TfrmZdyAttachCPCX.Create(Application);
    with frmZdyAttachCPCX do
    begin
//      fkhType:='';
      if ShowModal = 1 then
      begin
        Self.CDS_HZ.Edit;
        Self.CDS_HZ.FieldByName('CPHH').Value := Trim(CDS_HZ.fieldbyname('ZDYName').AsString);
      end;
    end;
  finally
    frmZdyAttachCPCX.Free;
  end;
//  try
//    frmZDYHelp := TfrmZDYHelp.Create(Application);
//    with frmZDYHelp do
//    begin
//      flag := 'CPhh';
//      flagname := 'Ʒ';
//      if ShowModal = 1 then
//      begin
//        Self.CDS_HZ.Edit;
//        Self.CDS_HZ.FieldByName('CPhh').Value := Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
//      end;
//    end;
//  finally
//    frmZDYHelp.Free;
//  end;
end;

procedure TfrmZdyAttInputPB.Tv2Column1PropertiesEditValueChanged(Sender: TObject);
var
  mvalue: string;
begin
  mvalue := TcxTextEdit(Sender).EditingText;

  if trim(mvalue) = '' then
    exit;

  if rightBstr(trim(mvalue), 1) <> '#' then
  begin
    mvalue := trim(mvalue) + '#';
  end;

  with CDS_HZ do
  begin
    Edit;
    FieldByName('CPHH').Value := Trim(mvalue);
    Post;
  end;
  self.tv2.Controller.EditingController.ShowEdit();

end;

end.

