unit U_ZdyAttachPB;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, ComObj,
  Dialogs, cxGraphics, cxCustomData, cxStyles, cxTL, cxMaskEdit, DB, ADODB,
  cxInplaceContainer, cxDBTL, cxControls, cxTLData, ComCtrls, ToolWin,
  StdCtrls, cxFilter, cxData, cxDataStorage, cxEdit, cxDBData, DBClient,
  cxGridCustomTableView, cxGridTableView, cxGridDBTableView, ExtCtrls,
  cxSplitter, cxGridLevel, cxClasses, cxGridCustomView, cxGrid,
  cxGridCustomPopupMenu, cxGridPopupMenu, RM_Dataset, RM_System, RM_Common,
  RM_Class, RM_GridReport, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient, IdFTP,ShellAPI,IniFiles, cxCheckBox, cxCalendar,
  cxButtonEdit, cxTextEdit, Menus, cxLookAndFeelPainters, cxButtons,
  cxLookAndFeels, cxNavigator;

type

  FdDy=record
               inc: integer; //ͻ׽־
               FDdys:string[32]; //ͻ׽
               FdDysName:string[32]; //ͻ׽
       end;
  TfrmZdyAttachPB = class(TForm)
    ToolBar1: TToolBar;
    TBRafresh: TToolButton;
    TBDel: TToolButton;
    TBClose: TToolButton;
    ADOQueryTemp: TADOQuery;
    ADOQueryCmd: TADOQuery;
    Panel1: TPanel;
    ToolButton2: TToolButton;
    ADOQueryMain: TADOQuery;
    ToolButton1: TToolButton;
    RM1: TRMGridReport;
    RMDB_Main: TRMDBDataSet;
    Label3: TLabel;
    ZdyName: TEdit;
    cxGrid2: TcxGrid;
    Tv2: TcxGridDBTableView;
    cxGridLevel1: TcxGridLevel;
    cxGridPopupMenu2: TcxGridPopupMenu;
    DS_HZ: TDataSource;
    CDS_HZ: TClientDataSet;
    ToolButton3: TToolButton;
    v2Column6: TcxGridDBColumn;
    v2Column1: TcxGridDBColumn;
    v2Column2: TcxGridDBColumn;
    v2Column3: TcxGridDBColumn;
    v2Column4: TcxGridDBColumn;
    v2Column5: TcxGridDBColumn;
    v2Column9: TcxGridDBColumn;
    Label1: TLabel;
    ZdyCode: TEdit;
    ToolButton4: TToolButton;
    Label2: TLabel;
    DEFstr5: TComboBox;
    v2Column7: TcxGridDBColumn;
    v2Column11: TcxGridDBColumn;
    v2Column12: TcxGridDBColumn;
    v2Column13: TcxGridDBColumn;
    OpenDialog1: TOpenDialog;
    ToolButton5: TToolButton;
    v2Mrate: TcxGridDBColumn;
    v2Column14: TcxGridDBColumn;
    v2Column15: TcxGridDBColumn;
    v2defflt1: TcxGridDBColumn;
    ToolButton6: TToolButton;
    Panel2: TPanel;
    RadioGroup1: TRadioGroup;
    Label4: TLabel;
    cxButton1: TcxButton;
    cxButton2: TcxButton;
    v2Column16: TcxGridDBColumn;
    Tv2Column1: TcxGridDBColumn;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TBCloseClick(Sender: TObject);
    procedure TBDelClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ZdyNameChange(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure ToolButton5Click(Sender: TObject);
    procedure cxButton2Click(Sender: TObject);
    procedure cxButton1Click(Sender: TObject);
    procedure ToolButton6Click(Sender: TObject);
  private
    { Private declarations }
    procedure InitGrid();

  public
        fkhType:string;
    dFdDy: array[0..20] of FdDy; //ͻ
  end;

var
  frmZdyAttachPB: TfrmZdyAttachPB;

implementation
uses
  U_DataLink,U_Fun,U_ZDYHelp,U_ZdyAttInputPB;

{$R *.dfm}



procedure TfrmZdyAttachPB.InitGrid();
begin
  try
    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Filtered:=False;
      Close;
      SQL.Clear;
      sql.Add(' select  ATID,ZdyName,ZdyCode,DEFstr1,DEFstr2,defNote1,Mrate,defNote2,defNote3,DEFstr3,DEFstr5,DEFstr4,');
      sql.Add(' DEFstr6,DEFstr7,DEFstr8,Note,DEFstr4,DEFstr5,defflt1,CPhh,Filler,FillTime  ');
      sql.Add(' from KH_Zdy_Attachment where Type=''CP'' and  DEFstr5='''' ');
      sql.Add(' and isnull(khType,'''')='+quotedstr(trim(fkhType)));
      sql.Add(' order by zdyName,dbo.getNum(Defstr3) ');
  //    sql.Add(' order by zdyName ');
      Open;
    end;
    SCreateCDS20(ADOQueryMain,CDS_HZ);
    SInitCDSData20(ADOQueryMain,CDS_HZ);
  finally
    ADOQueryMain.EnableControls;
  end;
end;


procedure TfrmZdyAttachPB.FormDestroy(Sender: TObject);
begin
  frmZdyAttachPB:=nil;
end;

procedure TfrmZdyAttachPB.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TfrmZdyAttachPB.TBCloseClick(Sender: TObject);
begin
  WriteCxGrid('Ʒ13',Tv2,'ͻԶ');
  Close;
end;
procedure TfrmZdyAttachPB.TBDelClick(Sender: TObject);
begin
  if CDS_HZ.IsEmpty then Exit;
  if Application.MessageBox('ȷҪɾ','ʾ',32+4)<>IDYES then Exit;
  if Trim(CDS_HZ.fieldbyname('ATID').AsString)<>'' then
  begin
    with ADOQueryCmd do
    begin
      Close;
      SQL.Clear;
      sql.Add('delete KH_Zdy_Attachment where ATID='''+Trim(CDS_HZ.fieldbyname('ATID').AsString)+'''');
      sql.Add('delete KH_Zdy where ZdyNo='''+Trim(CDS_HZ.fieldbyname('ATID').AsString)+'''');
      ExecSQL;
    end;
  end;
  CDS_HZ.Delete;
end;

procedure TfrmZdyAttachPB.FormShow(Sender: TObject);
begin
  ReadCxGrid('Ʒ13',Tv2,'ͻԶ');
  InitGrid();
end;

procedure TfrmZdyAttachPB.TBRafreshClick(Sender: TObject);
begin
  InitGrid();
end;

procedure TfrmZdyAttachPB.ToolButton2Click(Sender: TObject);
begin
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain,SGetFilters(Panel1,1,2));
    SCreateCDS20(ADOQueryMain,CDS_HZ);
    SInitCDSData20(ADOQueryMain,CDS_HZ);
  end;
end;

procedure TfrmZdyAttachPB.ZdyNameChange(Sender: TObject);
begin
  ToolButton2.Click;
end;


procedure TfrmZdyAttachPB.ToolButton1Click(Sender: TObject);
begin
  if ADOQueryMain.IsEmpty then Exit;
  TcxGridToExcel(self.Caption,cxgrid2);
//  SelExportData(Tv2,ADOQueryMain,'Ʒб');
end;

procedure TfrmZdyAttachPB.ToolButton4Click(Sender: TObject);
begin
  try
    frmZdyAttInputPB:=TfrmZdyAttInputPB.Create(Application);
    with frmZdyAttInputPB do
    begin
      FCYID:=Trim(Self.CDS_HZ.fieldbyname('ATID').AsString);
      fkhType:=self.fkhType;
      if ShowModal=1 then
      begin
        TBRafresh.Click;
      end;
    end;
  finally
    frmZdyAttInputPB.Free;
  end;
end;

procedure TfrmZdyAttachPB.ToolButton3Click(Sender: TObject);
begin
  try
    frmZdyAttInputPB:=TfrmZdyAttInputPB.Create(Application);
    with frmZdyAttInputPB do
    begin
      FCYID:='';
      fkhType:=self.fkhType;
      if ShowModal=1 then
      begin
        TBRafresh.Click;
      end;
    end;
  finally
    frmZdyAttInputPB.Free;
  end;
end;

procedure TfrmZdyAttachPB.ToolButton5Click(Sender: TObject);
var
  excelApp,WorkBook:Variant;
  i,j,k,ExcelRowCount:integer;
  maxId:string;
begin

  try
    ExcelApp := CreateOleObject('Excel.Application');
    openDialog1.Filter:='*.CSV;*.xls';
    if  opendialog1.Execute then
    begin
      WorkBook :=ExcelApp.WorkBooks.Open(OpenDialog1.FileName);
    end
    else
      exit;

     ExcelApp.Visible := false;
     ExcelRowCount := WorkBook.WorkSheets[1].UsedRange.Rows.Count;
  except
    application.MessageBox('EXCEL','Ϣ',MB_ICONERROR);
    exit;
  end;

  try
    k:=0;
    for i:=1  to 20 do
    begin
      if trim(excelapp.Cells[1,i].value)='' then break;
      if trim(excelapp.Cells[1,i].value)='Ʒ' then
      begin
        dFdDy[k].inc:=i;
        dFdDy[k].FDdys:='ZdyCode';
        dFdDy[k].FdDysName:='Ʒ';
      end;

      if trim(excelapp.Cells[1,i].value)='Ʒ' then
      begin
        dFdDy[k].inc:=i;
        dFdDy[k].FDdys:='ZdyName';
        dFdDy[k].FdDysName:='Ʒ';
      end;

      if trim(excelapp.Cells[1,i].value)='' then
      begin
        dFdDy[k].inc:=i;
        dFdDy[k].FDdys:='defNote3';
        dFdDy[k].FdDysName:='';
      end;

      if trim(excelapp.Cells[1,i].value)='ɫ' then
      begin
        dFdDy[k].inc:=i;
        dFdDy[k].FDdys:='DEFstr3';
        dFdDy[k].FdDysName:='ɫ';
      end;
      if trim(excelapp.Cells[1,i].value)='ɫ' then
      begin
        dFdDy[k].inc:=i;
        dFdDy[k].FDdys:='DEFstr6';
        dFdDy[k].FdDysName:='ɫ';
      end;


      if trim(excelapp.Cells[1,i].value)='' then
      begin
        dFdDy[k].inc:=i;
        dFdDy[k].FDdys:='DEFstr5';
        dFdDy[k].FdDysName:='';
      end;
      if trim(excelapp.Cells[1,i].value)='' then
      begin
        dFdDy[k].inc:=i;
        dFdDy[k].FDdys:='DEFstr1';
        dFdDy[k].FdDysName:='';
      end;
      if trim(excelapp.Cells[1,i].value)='ɷ' then
      begin
        dFdDy[k].inc:=i;
        dFdDy[k].FDdys:='DEFstr2';
        dFdDy[k].FdDysName:='ɷ';
      end;
      k:=k+1;
    end;
  except
  end;

  ADOQueryCmd.Connection.BeginTrans;
  try
    for i := 2 to excelrowcount do
    begin
      if GetLSNo(ADOQueryCmd,maxId,'AT','KH_Zdy_Attachment',4,1)=False then
      begin
        ADOQueryCmd.Connection.RollbackTrans;
        Application.MessageBox('ȡʧܣ','ʾ',0);
        Exit;
      end;

      with ADOQueryCmd do
      begin
        close;
        sql.Clear;
        sql.Add('select * from KH_Zdy_Attachment where 1=2');
        open;
      end;
      ADOQueryCmd.Append;
      for j:=0 to k-1 do
      begin
        ADOQueryCmd.fieldbyname(dFdDy[j].FDdys).Value:=excelapp.Cells[i,dFdDy[j].inc].Value;
      end;
      ADOQueryCmd.FieldByName('ATID').Value:=Trim(maxId);
      ADOQueryCmd.FieldByName('zdyCode').Value:=Trim(maxId);
      ADOQueryCmd.FieldByName('khType').Value:=Trim(fkhType);
      ADOQueryCmd.FieldByName('Type').Value:='CP';
      ADOQueryCmd.FieldByName('Filler').Value:=Trim(DName);
      ADOQueryCmd.Post;

    end;
    WorkBook.Close;
    ExcelApp.Quit;
    ExcelApp := Unassigned;
    WorkBook := Unassigned;
    ADOQueryCmd.Connection.CommitTrans;
    InitGrid();
  except
    WorkBook.Close;
    ExcelApp.Quit;
    ExcelApp := Unassigned;
    WorkBook := Unassigned;
     ADOQueryCmd.Connection.RollbackTrans;
  end;
end;

procedure TfrmZdyAttachPB.cxButton2Click(Sender: TObject);
begin
  Panel2.Visible:=false;
end;

procedure TfrmZdyAttachPB.cxButton1Click(Sender: TObject);
var
  fPrintFile:string;
   Txt,fImagePath:string;
   Moudle: THandle;
   Makebar:TMakebar;
   Mixtext:TMixtext;
begin
  IF CDS_HZ.IsEmpty then exit;
        try
          Moudle:=LoadLibrary('MakeQRBarcode.dll');
          @Makebar:=GetProcAddress(Moudle,'Make');
          @Mixtext:=GetProcAddress(Moudle,'MixText');
          Txt:=Trim(CDS_HZ.fieldbyname('ZDYCODE').AsString);
          fImagePath:=ExtractFilePath(Application.ExeName)+'image\temp.bmp' ;
          if not DirectoryExists(pchar(ExtractFilePath(Application.ExeName)+'image')) then
          CreateDirectory(pchar(ExtractFilePath(Application.ExeName)+'image'),nil);
          if FileExists(fImagePath) then DeleteFile(fImagePath);
          Makebar(pchar(Txt),Length(Txt),3,3,0,PChar(fImagePath),3);
        except
          application.MessageBox('ʧܣ','ʾϢ',MB_ICONERROR);
         exit;
        end;

  fPrintFile:=ExtractFilePath(Application.ExeName)+'Report\'+trim(RadioGroup1.Items[RadioGroup1.ItemIndex])+'.rmf' ;
  if FileExists(fPrintFile) then
  begin
    RMVariables['QRBARCODE']:=fImagePath;
    RM1.LoadFromFile(fPrintFile);
 //   Rm2.DefaultCopies:=strtointdef(trim(ComboBox1.Text),1);
   // RM1.ShowReport;
    RM1.PrintReport;
  end
  else
     Application.MessageBox(PChar('ûҵļ'+fPrintFile),'ʾ',0);

end;

procedure TfrmZdyAttachPB.ToolButton6Click(Sender: TObject);
begin
 Panel2.Left:=(self.Width-Panel2.Width) div 2;
  Panel2.Top:=(self.Height-Panel2.Height) div 2 -100;
  Panel2.Visible:=true;
end;

end.


