unit U_FKCR;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxGraphics, cxCustomData, cxStyles, cxTL, cxMaskEdit, DB, ADODB,
  cxInplaceContainer, cxDBTL, cxControls, cxTLData, ComCtrls, ToolWin,
  StdCtrls, cxFilter, cxData, cxDataStorage, cxEdit, cxDBData, DBClient,
  cxGridCustomTableView, cxGridTableView, cxGridDBTableView, ExtCtrls,
  cxSplitter, cxGridLevel, cxClasses, cxGridCustomView, cxGrid,
  cxGridCustomPopupMenu, cxGridPopupMenu, RM_Dataset, RM_System, RM_Common,
  RM_Class, RM_GridReport, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient, IdFTP,ShellAPI,IniFiles, cxCheckBox, cxCalendar,
  cxButtonEdit, cxTextEdit, cxLookAndFeels, cxLookAndFeelPainters,
  cxNavigator;

type
  TfrmFKCR = class(TForm)
    ToolBar1: TToolBar;
    TBRafresh: TToolButton;
    TBDel: TToolButton;
    TBClose: TToolButton;
    ADOQueryTemp: TADOQuery;
    ADOQueryCmd: TADOQuery;
    Panel1: TPanel;
    ToolButton2: TToolButton;
    Label1: TLabel;
    YFName: TEdit;
    ADOQueryMain: TADOQuery;
    ToolButton1: TToolButton;
    RM1: TRMGridReport;
    RMDB_Main: TRMDBDataSet;
    Label3: TLabel;
    FactoryName: TEdit;
    cxGrid2: TcxGrid;
    Tv2: TcxGridDBTableView;
    cxGridDBColumn1: TcxGridDBColumn;
    cxGridDBColumn3: TcxGridDBColumn;
    cxGridLevel1: TcxGridLevel;
    Label2: TLabel;
    Label6: TLabel;
    begdate: TDateTimePicker;
    Enddate: TDateTimePicker;
    cxGridPopupMenu2: TcxGridPopupMenu;
    DS_HZ: TDataSource;
    CDS_HZ: TClientDataSet;
    ToolButton3: TToolButton;
    VHL: TcxGridDBColumn;
    VBZ: TcxGridDBColumn;
    VYB: TcxGridDBColumn;
    VBB: TcxGridDBColumn;
    v2Column6: TcxGridDBColumn;
    VOrderNo: TcxGridDBColumn;
    Label4: TLabel;
    conNo: TEdit;
    v2Column1: TcxGridDBColumn;
    v2DerateMoney: TcxGridDBColumn;
    v2fstr1: TcxGridDBColumn;
    v2Column2: TcxGridDBColumn;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    Tv2Column1: TcxGridDBColumn;
    CheckBox1: TCheckBox;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TBCloseClick(Sender: TObject);
    procedure TBDelClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure FactoryNameChange(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure cxGridDBColumn8PropertiesEditValueChanged(Sender: TObject);
    procedure cxGridDBColumn5PropertiesEditValueChanged(Sender: TObject);
    procedure cxGridDBColumn1PropertiesEditValueChanged(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure cxGridDBColumn3PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure cxGridDBColumn6PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v2Column3PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure ToolButton1Click(Sender: TObject);
    procedure v2Column4PropertiesEditValueChanged(Sender: TObject);
    procedure v2Column1PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure VBBPropertiesEditValueChanged(Sender: TObject);
    procedure conNoChange(Sender: TObject);
    procedure v2Column1PropertiesEditValueChanged(Sender: TObject);
    procedure v2DerateMoneyPropertiesEditValueChanged(Sender: TObject);
    procedure v2fstr1PropertiesEditValueChanged(Sender: TObject);
    procedure v2Column2PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure ToolButton4Click(Sender: TObject);
    procedure ToolButton5Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private declarations }
    fopevent:string;
    procedure InitGridHZ();
    procedure InitGrid();
    procedure geteditRzhi();
    function  SaveData():Boolean;
    function  SaveZL():Boolean;
  public
    fflag:integer;
    fsyrName:string;
    { Public declarations }
    RKFlag,FCYID:String;

  end;

var
  frmFKCR: TfrmFKCR;

implementation
uses
  U_DataLink,U_Fun,U_ZDYHelp, U_ProductOrderList, U_ProductOrderNewList,
  U_PbProductList, U_ZdyAttachGYS, U_SysLogHelp;

{$R *.dfm}

procedure TfrmFKCR.geteditRzhi();
begin
  fopevent:='';
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    SQL.Add('select * from YF_Money_LL where fromMainID='''+Trim(CDS_HZ.fieldbyname('YFID').AsString)+''' ');
    open;
  end;
  IF not ADOQueryTemp.IsEmpty then
  begin

      IF formatdateTime('yyyy-MM-dd',CDS_HZ.fieldbyname('CRTime').AsDateTime)<> formatdateTime('yyyy-MM-dd',ADOQueryTemp.fieldbyName('CRTime').AsDateTime) then
      fopevent:=fopevent+' :'+formatdateTime('yyyy-MM-dd',ADOQueryTemp.fieldbyName('CRTime').AsDateTime )+'->'+formatdateTime('yyyy-MM-dd',CDS_HZ.fieldbyname('CRTime').AsDateTime);

      IF CDS_HZ.fieldbyname('Money').AsFloat<> ADOQueryTemp.fieldbyName('outMoney').AsFloat then
      fopevent:=fopevent+' :'+ADOQueryTemp.fieldbyName('outMoney').AsString+'->'+CDS_HZ.fieldbyname('Money').AsString;

      IF trim(CDS_HZ.fieldbyname('bankNo').AsString)<> trim(ADOQueryTemp.fieldbyName('factoryName').AsString) then
      fopevent:=fopevent+' ˻:'+trim(ADOQueryTemp.fieldbyName('factoryName').AsString)+'->'+trim(CDS_HZ.fieldbyname('bankNo').AsString);

      IF fopevent<>'' then
      fopevent:='Էλ:'+Trim(CDS_HZ.fieldbyname('factoryName').AsString)+fopevent;
  end;
end;

function  TfrmFKCR.SaveZL():Boolean;
var
  LLNO:string;
begin
  if GetLSNo(ADOQueryCMD,LLNO,'YL','YF_Money_LL',3,1)=False then
  begin
    ADOQueryCMD.Connection.RollbackTrans;
    Application.MessageBox('ȡˮʧ!','ʾ');
    Exit;
  end;
  result:=false;
  try

    with ADOqueryCmd do
    begin
      Close;
      sql.Clear;
      SQL.Add('delete from YF_Money_LL where fromMainID='''+Trim(CDS_HZ.fieldbyname('YFID').AsString)+''' ');
      execsql;
    end;
    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      SQL.Add('select * from YF_Money_LL where fromMainID='''+Trim(CDS_HZ.fieldbyname('YFID').AsString)+''' ');
      Open;
      append;
      fieldbyname('filler').Value:=trim(Dname);
      FieldByName('LLNO').Value:=Trim(LLNO);
      fieldbyname('CRTime').Value:=formatdateTime('yyyy-MM-dd',CDS_HZ.fieldbyname('CRTime').AsDateTime);
      fieldbyname('CRType').Value:=Trim(CDS_HZ.fieldbyname('YFName').AsString);
      fieldbyname('factoryName').Value:=Trim(CDS_HZ.fieldbyname('bankNo').AsString);
      fieldbyname('TOfactoryName').Value:=Trim(CDS_HZ.fieldbyname('factoryName').AsString);
      fieldbyname('NOTE').Value:=Trim(CDS_HZ.fieldbyname('note').AsString);
      fieldbyname('inMoney').Value:=0;
      fieldbyname('OutMoney').Value:=CDS_HZ.fieldbyname('Money').AsFloat;
      fieldbyname('status').Value:='0';
      FieldByName('fromMainID').Value:=Trim(CDS_HZ.fieldbyname('YFID').AsString);
      FieldByName('syrName').Value:=Trim(fsyrName);
      Post;
    end;
    IF trim(fopevent)<>'' then
    begin
      with ADOQueryCmd do
      begin
        Close;
        sql.Clear;
        sql.Add('insert into SY_SysLog(operor,opertime,Model,acction,opevent,result) values( ');
        sql.Add(' '+quotedstr(trim(DName)));
        sql.Add(',getdate() ');
        sql.Add(','+quotedstr(trim('Ǽ')));
        sql.Add(','+quotedstr(trim('Ǽ޸')));
        sql.Add(','+quotedstr(trim(fopevent)));
        sql.Add(','+quotedstr(trim('ɹ')));
        sql.Add(')');
        execsql;
      end;
    end;
    result:=true;
  except
  end;
end;




procedure TfrmFKCR.InitGrid();
begin
  try
    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Filtered:=False;
      Close;
      SQL.Clear;
      sql.Add(' select A.*,C.conNo ');
      sql.Add(',KHZJM=dbo.getPinYin(A.FactoryName)');
      sql.Add('  from YF_Money_CR A');
      sql.Add(' inner join YF_Money_KC B on A.CRID=B.CRID');
      SQL.Add(' left join conTract_main C on A.MainId=C.MainId');
      sql.Add('where A.CRTime>=:begdate and A.CRTime<:Enddate and A.CRType=''Ǽ''  and a.YFDefFlag1='''+inttostr(fflag)+'''   ');
      Parameters.ParamByName('begdate').Value:=Trim(FormatDateTime('yyyy-MM-dd',begdate.DateTime));
      Parameters.ParamByName('Enddate').Value:=Trim(FormatDateTime('yyyy-MM-dd',Enddate.DateTime+1));
      Open;
    end;
    SCreateCDS20(ADOQueryMain,CDS_HZ);
    SInitCDSData20(ADOQueryMain,CDS_HZ);
  finally
    ADOQueryMain.EnableControls;
    ToolButton2.Click;
  end;
end;
procedure TfrmFKCR.InitGridHZ();
begin
end;

procedure TfrmFKCR.FormDestroy(Sender: TObject);
begin
  frmFKCR:=nil;
end;

procedure TfrmFKCR.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TfrmFKCR.TBCloseClick(Sender: TObject);
begin
  WriteCxGrid('Ǽ',Tv2,'');
  Close;
end;
procedure TfrmFKCR.TBDelClick(Sender: TObject);
var
  FBBMoney,CRID:string;
begin
  if CDS_HZ.IsEmpty then Exit;

  if Application.MessageBox('ȷҪɾ','ʾ',32+4)<>IDYES then Exit;
  if Trim(CDS_HZ.fieldbyname('YFID').AsString)<>'' then
  begin
    with ADOQueryCmd do
    begin
      Close;
      SQL.Clear;
      sql.Add('delete YF_Money_CR where YFID='''+Trim(CDS_HZ.fieldbyname('YFID').AsString)+'''');
      sql.Add('delete YF_Money_LL where fromMainID='''+Trim(CDS_HZ.fieldbyname('YFID').AsString)+'''');
      sql.Add('insert into SY_SysLog(operor,opertime,Model,acction,opevent,result) values( ');
      sql.Add(' '+quotedstr(trim(DName)));
      sql.Add(',getdate() ');
      sql.Add(','+quotedstr(trim(self.Caption)));
      sql.Add(','+quotedstr(trim('ɾ')));
      sql.Add(','+quotedstr(trim('Ӧ:'+trim(CDS_HZ.FieldByName('factoryName').AsString)+' :'+trim(CDS_HZ.FieldByName('money').AsString))));
      sql.Add(','+quotedstr(trim('ɹ')));
      sql.Add(')');
      ExecSQL;
    end;
  end;
  CDS_HZ.Delete;
end;

procedure TfrmFKCR.FormShow(Sender: TObject);
begin
  ReadCxGrid('Ǽ',Tv2,'');
  Enddate.DateTime:=SGetServerDate(ADOQueryTemp);
  begdate.DateTime:=Enddate.DateTime;
  if Trim(DParameters1)='޶' then
  begin
    VOrderNo.Hidden:=True;
    VOrderNo.Visible:=False;
    label4.Visible:=False;
    conNo.Visible:=False;
  end;
  if Trim(DParameters2)='' then
  begin
    VHL.Hidden:=True;
    VHL.Visible:=False;
    VBZ.Hidden:=True;
    VBZ.Visible:=False;
    VYB.Hidden:=True;
    VYB.Visible:=False;
    VBB.Caption:='ʵ';
  end;
  InitGrid();
end;

procedure TfrmFKCR.TBRafreshClick(Sender: TObject);
begin
  InitGrid();
end;

procedure TfrmFKCR.ToolButton2Click(Sender: TObject);
var
  fsj:string;
begin
  if ADOQueryMain.Active=False then Exit;
  if Trim(SGetFilters(Panel1,1,2))='' then
  begin
    if Trim(FactoryName.Text)<>'' then
    begin
      fsj:=' FactoryName like '''+'%'+Trim(FactoryName.Text)+'%'+''''
         +' or KHZJM like '''+'%'+Trim(FactoryName.Text)+'%'+'''';
    end;

  end else
  begin
    if Trim(FactoryName.Text)<>'' then
    begin
      fsj:=SGetFilters(Panel1,1,2)+' and (FactoryName like '''+'%'+Trim(FactoryName.Text)+'%'+''''
         +' or KHZJM like '''+'%'+Trim(FactoryName.Text)+'%'+''')';
    end;
  end;
  SDofilter(ADOQueryMain,fsj);
  SCreateCDS20(ADOQueryMain,CDS_HZ);
  SInitCDSData20(ADOQueryMain,CDS_HZ);
end;

procedure TfrmFKCR.FactoryNameChange(Sender: TObject);
begin
  ToolButton2.Click;
end;

procedure TfrmFKCR.Button2Click(Sender: TObject);
begin
  if CDS_HZ.IsEmpty then Exit;
  if Application.MessageBox('ȷҪɾ','ʾ',32+4)<>IDYES then Exit;
  if Trim(CDS_HZ.fieldbyname('SubID').AsString)<>'' then
  begin
    with ADOQueryCmd do
    begin
      Close;
      SQL.Clear;
      sql.Add('delete YCL_SG_HZ where SubID='''+Trim(CDS_HZ.fieldbyname('SubID').AsString)+'''');
      ExecSQL;
    end;
  end;
  CDS_HZ.Delete;
end;

function TfrmFKCR.SaveData():Boolean;
var
  maxId,CRID:String;
begin
  try
    ADOQueryCmd.Connection.BeginTrans;
    if GetLSNo(ADOQueryCmd,maxId,'FK','YF_Money_CR',4,1)=False then
    begin
      Result:=False;
      ADOQueryCmd.Connection.RollbackTrans;
      Application.MessageBox('ȡʧܣ','ʾ',0);
      Exit;
    end;
    with ADOQueryCmd do
    begin
      Close;
      SQL.Clear;
      sql.Add('select * from YF_Money_KC where FactoryName='''+Trim(CDS_HZ.fieldbyname('FactoryName').AsString)+'''');
      Open;
    end;
    if ADOQueryCmd.IsEmpty=False then
    begin
      CRID:=ADOQueryCmd.fieldbyname('CRID').AsString;
    end else
    begin
      with ADOQueryCmd do
      begin
        Close;
        sql.Clear;
        sql.Add('Update YF_Money_CRID set CRID=CRID+1');
        sql.Add('select * from YF_Money_CRID ');
        Open;
      end;
      CRID:=ADOQueryCmd.fieldbyname('CRID').AsString;
      with ADOQueryCmd do
      begin
        Close;
        SQL.Clear;
        sql.Add('select * from YF_Money_KC where 1<>1');
        Open;
      end;
      with ADOQueryCmd do
      begin
        Append;
        FieldByName('CRID').Value:=StrToInt(CRID);
        FieldByName('FactoryNo').Value:=Trim(CDS_HZ.fieldbyname('FactoryNo').AsString);
        FieldByName('FactoryName').Value:=Trim(CDS_HZ.fieldbyname('FactoryName').AsString);
        FieldByName('ZdyStr1').Value:='Ӧ';
        Post;
      end;
    end;
    with ADOQueryCmd do
    begin
      Close;
      SQL.Clear;
      sql.Add('select * from YF_Money_CR where 1<>1');
      Open;
    end;
    with ADOQueryCmd do
    begin
      Append;
      FieldByName('YFID').Value:=Trim(maxId);
      FieldByName('CRID').Value:=StrToInt(CRID);
      //SSetSaveDataCDSNew(ADOQueryCmd,Tv2,CDS_HZ,'YF_Money_CR',3);
      FieldByName('Filler').Value:=Trim(DName);
      FieldByName('CRType').Value:='Ǽ';
      FieldByName('CRFlag').Value:='Ӧ';
      FieldByName('QtyFlag').Value:=-1;
      FieldByName('FactoryNo').Value:=Trim(CDS_HZ.fieldbyname('FactoryNo').AsString);
      FieldByName('FactoryName').Value:=Trim(CDS_HZ.fieldbyname('FactoryName').AsString);
      FieldByName('CRTime').Value:=formatdateTIme('yyyy-MM-dd',CDS_HZ.fieldbyname('CRTime').AsDateTime);
      FieldByName('YFDefFlag1').Value:=fFlag;
      Post;
    end;
    with CDS_HZ do
    begin
      Edit;
      FieldByName('YFId').Value:=Trim(maxId);
      FieldByName('CRID').Value:=StrToInt(CRID);
    end;
    ADOQueryCmd.Connection.CommitTrans;
    Result:=True;
  except
    Result:=True;
    ADOQueryCmd.Connection.RollbackTrans;
    Application.MessageBox('ʧ!','ʾ',0);
  end;
end;

procedure TfrmFKCR.cxGridDBColumn8PropertiesEditValueChanged(
  Sender: TObject);
var
  mvalue,FFieldName:String;
begin
  mvalue:=TcxTextEdit(Sender).EditingText;
  FFieldName:=Trim(Tv2.Controller.FocusedColumn.DataBinding.FilterFieldName);
  with CDS_HZ do
  begin
    Edit;
    FieldByName(FFieldName).Value:=Trim(mvalue);
    Post;
  end;
  with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add('UPdate YCL_SG_HZ ');
    if Trim(mvalue)<>'' then
    begin
      sql.Add(' Set '+FFieldName+'='''+Trim(mvalue)+'''');
    end else
    begin
      sql.Add(' Set '+FFieldName+'=NULL');
    end;
    SQL.Add(',Editer='''+Trim(DName)+'''');
    SQL.Add(',Edittime=getdate() ');
    SQL.Add(' where SubId='''+Trim(CDS_HZ.fieldbyname('SubId').AsString)+'''');
    ExecSQL;
  end;
end;

procedure TfrmFKCR.cxGridDBColumn5PropertiesEditValueChanged(
  Sender: TObject);
var
  mvalue,FQty,FPrice,FMoney,FHuiLv,FBBMoney,FKCBB,FFieldName:String;
begin
  mvalue:=TcxTextEdit(Sender).EditingText;
  if Trim(mvalue)='' then
  begin
    mvalue:='0';
  end;
  FFieldName:=Trim(Tv2.Controller.FocusedColumn.DataBinding.FilterFieldName);
  with CDS_HZ do
  begin
    Edit;
    FieldByName(FFieldName).Value:=Trim(mvalue);
    Post;
  end;
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add('select isnull(BBMoney,0) BBMoney from YF_Money_CR where YFID='''+cds_hz.fieldbyname('YFID').AsString+'''');
    Open;
  end;
  FKCBB:=ADOQueryTemp.fieldbyname('BBMoney').AsString;

  FQty:=Trim(CDS_HZ.fieldbyname('Qty').AsString);
  if Trim(FQty)='' then FQty:='0';

  FPrice:=Trim(CDS_HZ.fieldbyname('Price').AsString);
  if Trim(FPrice)='' then FPrice:='0';
  FQty:=Trim(CDS_HZ.fieldbyname('Qty').AsString);
  if Trim(FQty)='' then FQty:='0';

  FMoney:=Trim(CDS_HZ.fieldbyname('Money').AsString);
  if Trim(FMoney)='' then FMoney:='0';

  FHuiLv:=Trim(CDS_HZ.fieldbyname('HuiLv').AsString);
  if Trim(FHuiLv)='' then FHuiLv:='0';

  {FBBMoney:=Trim(CDS_HZ.fieldbyname('BBMoney').AsString);
  if Trim(FBBMoney)='' then FBBMoney:='0'; }

  if Trim(FFieldName)<>'Money' then
  begin
    if Trim(FFieldName)<>'HuiLv' then
    begin
      FBBMoney:=FloatToStr(StrToFloat(FQty)*StrToFloat(FPrice)*StrToFloat(FHuiLv));
      FMoney:=FloatToStr(StrToFloat(FQty)*StrToFloat(FPrice));
    end else
    begin
      FBBMoney:=FloatToStr(StrToFloat(FMoney)*StrToFloat(FHuiLv));
    end;

  end else
  begin
    FBBMoney:=FloatToStr(StrToFloat(FMoney)*StrToFloat(FHuiLv));
  end;
  with CDS_HZ do
  begin
    Edit;
    FieldByName('Money').Value:=StrToFloat(FMoney);
    FieldByName('BBMoney').Value:=StrToFloat(FBBMoney);
    Post;
  end;
  with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add('UPdate YF_Money_CR ');
    sql.Add(' Set '+FFieldName+'='+Trim(mvalue));
    if Trim(FFieldName)<>'Money' then
    begin
      sql.Add(',Money='+FMoney);
    end;

    sql.Add(',BBMoney='+FBBMoney);
    SQL.Add(',Editer='''+Trim(DName)+'''');
    SQL.Add(',Edittime=getdate() ');
    SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
    
    SQL.Add('Update YF_Money_KC Set KCBBMoney=KCBBMoney-'+FKCBB+'+'+FBBMoney);
    sql.Add(' where CRID='''+Trim(CDS_HZ.fieldbyname('CRID').AsString)+'''');
    ExecSQL;
  end;
end;

procedure TfrmFKCR.cxGridDBColumn1PropertiesEditValueChanged(
  Sender: TObject);
var
  mvalue,FFieldName:String;
begin
  mvalue:=TcxTextEdit(Sender).EditingText;
  FFieldName:=Trim(Tv2.Controller.FocusedColumn.DataBinding.FilterFieldName);
  with CDS_HZ do
  begin
    Edit;
    FieldByName(FFieldName).Value:=Trim(mvalue);
    Post;
  end;
  with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add('UPdate YF_Money_CR ');
    if Trim(mvalue)<>'' then
    begin
      sql.Add(' Set '+FFieldName+'='''+Trim(mvalue)+'''');
    end else
    begin
      sql.Add(' Set '+FFieldName+'=NULL');
    end;
    SQL.Add(',Editer='''+Trim(DName)+'''');
    SQL.Add(',Edittime=getdate() ');
    SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
    ExecSQL;
  end;
  try
    geteditRzhi();
    with ADOqueryCmd do
    begin
      Close;
      sql.Clear;
      SQL.Add('delete from YF_Money_LL where fromMainID='''+Trim(CDS_HZ.fieldbyname('YFID').AsString)+''' ');
      execsql;
    end;
    IF (CDS_HZ.FieldByName('money').AsFloat<>0) and
       (trim(CDS_HZ.fieldbyname('bankNo').AsString)<>'') then
    begin
      IF not saveZL() then
      begin
        application.MessageBox('˻ˮϢʧ','ʾϢ',0);
      end;
    end;
  except
  end;
end;

procedure TfrmFKCR.ToolButton3Click(Sender: TObject);
begin
  try
    frmZdyAttachGYS:=TfrmZdyAttachGYS.Create(Application);
    with frmZdyAttachGYS do
    begin
      if ShowModal=1 then
      begin
        with Self.CDS_HZ do
        begin
          Append;
          FieldByName('FactoryNo').Value:=Trim(CDS_HZ.fieldbyname('ZdyCode').AsString);
          FieldByName('FactoryName').Value:=Trim(CDS_HZ.fieldbyname('ZdyName').AsString);
          FieldByName('CRTime').Value:=SGetServerDate(ADOQueryTemp);
          if Trim(DParameters2)='' then
          begin
            FieldByName('HuiLv').Value:=1;
          end;
          Post;
        end;
        Self.SaveData();
      end;
    end;
  finally
    frmZdyAttachGYS.Free;
  end;

end;

procedure TfrmFKCR.cxGridDBColumn3PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='YFName';
      flagname:='ĿժҪ';
      if Trim(DParameters3)='Ŀֿ' then
        MainType:='';
      if ShowModal=1 then
      begin
        with Self.CDS_HZ do
        begin
          Edit;
          FieldByName('YFCode').Value:=Trim(ClientDataSet1.fieldbyname('ZdyNo').AsString);
          FieldByName('YFName').Value:=Trim(ClientDataSet1.fieldbyname('ZdyName').AsString);
        end;
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('UPdate YF_Money_CR ');
          sql.Add(' Set YFCode='''+Trim(ClientDataSet1.fieldbyname('ZdyNo').AsString)+'''');
          sql.Add(' ,YFName='''+Trim(ClientDataSet1.fieldbyname('ZdyName').AsString)+'''');
          SQL.Add(',Editer='''+Trim(DName)+'''');
          SQL.Add(',Edittime=getdate() ');
          SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
          ExecSQL;
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmFKCR.cxGridDBColumn6PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='OrderUnit';
      flagname:='λ';
      if ShowModal=1 then
      begin
        Self.CDS_HZ.Edit;
        Self.CDS_HZ.FieldByName('QtyUnit').Value:=Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('UPdate YF_Money_CR ');
          sql.Add(' Set QtyUnit='''+Trim(ClientDataSet1.fieldbyname('ZdyName').AsString)+'''');
          SQL.Add(',Editer='''+Trim(DName)+'''');
          SQL.Add(',Edittime=getdate() ');
          SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
          ExecSQL;
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmFKCR.v2Column3PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='BZType';
      flagname:='';
      if ShowModal=1 then
      begin
        Self.CDS_HZ.Edit;
        Self.CDS_HZ.FieldByName('BZType').Value:=Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('UPdate YF_Money_CR ');
          sql.Add(' Set BZType='''+Trim(ClientDataSet1.fieldbyname('ZdyName').AsString)+'''');
          SQL.Add(',Editer='''+Trim(DName)+'''');
          SQL.Add(',Edittime=getdate() ');
          SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
          ExecSQL;
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmFKCR.ToolButton1Click(Sender: TObject);
begin
  if ADOQueryMain.IsEmpty then Exit;
  SelExportData(Tv2,ADOQueryMain,'б');
end;

procedure TfrmFKCR.v2Column4PropertiesEditValueChanged(Sender: TObject);
var
  mvalue,FMoney,FHuiLv,FBBMoney,FKCBB,FFieldName:String;
begin
  mvalue:=TcxTextEdit(Sender).EditingText;
  if Trim(mvalue)='' then
  begin
    mvalue:='0';
  end;
  FFieldName:=Trim(Tv2.Controller.FocusedColumn.DataBinding.FilterFieldName);
  with CDS_HZ do
  begin
    Edit;
    FieldByName(FFieldName).Value:=Trim(mvalue);
    Post;
  end;
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add('select isnull(BBMoney,0) BBMoney from YF_Money_CR where YFID='''+cds_hz.fieldbyname('YFID').AsString+'''');
    Open;
  end;
  FKCBB:=ADOQueryTemp.fieldbyname('BBMoney').AsString;

  FMoney:=Trim(CDS_HZ.fieldbyname('Money').AsString);
  if Trim(FMoney)='' then FMoney:='0';

  FHuiLv:=Trim(CDS_HZ.fieldbyname('HuiLv').AsString);
  if Trim(FHuiLv)='' then FHuiLv:='0';


  FBBMoney:=FloatToStr(StrToFloat(FMoney)*StrToFloat(FHuiLv));
  with CDS_HZ do
  begin
    Edit;
    FieldByName('Money').Value:=StrToFloat(FMoney);
    FieldByName('BBMoney').Value:=StrToFloat(FBBMoney);
    Post;
  end;
{  with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add('UPdate YF_Money_CR ');
    sql.Add(' Set '+FFieldName+'='+Trim(mvalue));
    sql.Add(',BBMoney='+FBBMoney);
    SQL.Add(',Editer='''+Trim(DName)+'''');
    SQL.Add(',Edittime=getdate() ');
    SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
    
    SQL.Add('Update YF_Money_KC Set KCBBMoney=KCBBMoney+'+FKCBB+'-'+FBBMoney);
    sql.Add(' where CRID='''+Trim(CDS_HZ.fieldbyname('CRID').AsString)+'''');
    ExecSQL;
  end;
  try
    geteditRzhi();
    with ADOqueryCmd do
    begin
      Close;
      sql.Clear;
      SQL.Add('delete from YF_Money_LL where fromMainID='''+Trim(CDS_HZ.fieldbyname('YFID').AsString)+''' ');
      execsql;
    end;
    IF (CDS_HZ.FieldByName('money').AsFloat<>0) and
       (trim(CDS_HZ.fieldbyname('bankNo').AsString)<>'') then
    begin
      IF not saveZL() then
      begin
        application.MessageBox('˻ˮϢʧ','ʾϢ',0);
      end;
    end;
  except
  end;  }
end;

procedure TfrmFKCR.v2Column1PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmPbProductList:=TfrmPbProductList.Create(Application);
    with frmPbProductList do
    begin
     // DParameters1:='Ȩ';
      //frmProductOrderList.v1Column4.Visible:=True;
      if ShowModal=1 then
      begin
        with Self.CDS_HZ do
        begin
          Edit;
          FieldByName('MainId').Value:=Trim(frmPbProductList.Order_Main.fieldbyname('MainId').AsString);
          FieldByName('subID').Value:=Trim(frmPbProductList.Order_Main.fieldbyname('subID').AsString);
          FieldByName('conNo').Value:=Trim(frmPbProductList.Order_Main.fieldbyname('conNo').AsString);
          post;
          with ADOQueryCmd do
          begin
            Close;
            sql.Clear;
            sql.Add('UPdate YF_Money_CR ');
            sql.Add(' Set MainId='''+Trim(frmPbProductList.Order_Main.fieldbyname('MainId').AsString)+'''');
            sql.Add(' ,SubId='''+Trim(frmPbProductList.Order_Main.fieldbyname('SubId').AsString)+'''');
            SQL.Add(',Editer='''+Trim(DName)+'''');
            SQL.Add(',Edittime=getdate() ');
            SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
            ExecSQL;
          end;
        end;
      end;
    end;
  finally
    frmPbProductList.Free;
    self.Tv2.Controller.EditingController.ShowEdit();
  end;
end;

procedure TfrmFKCR.VBBPropertiesEditValueChanged(Sender: TObject);
var
  mvalue,FKCBB:string;
begin
  mvalue:=TcxTextEdit(Sender).EditingText;
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add('select isnull(BBMoney,0) BBMoney from YF_Money_CR where YFID='''+cds_hz.fieldbyname('YFID').AsString+'''');
    Open;
  end;
  FKCBB:=ADOQueryTemp.fieldbyname('BBMoney').AsString;
  if Trim(mvalue)='' then mvalue:='0';
  with CDS_HZ do
  begin
    Edit;
    FieldByName('BBMoney').Value:=StrToFloat(mvalue);
    FieldByName('Money').Value:=StrToFloat(mvalue);
    Post;
  end;
 { with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add('UPdate YF_Money_CR ');
    sql.Add(' set BBMoney='+mvalue);
    sql.Add(' ,Money='+mvalue);
    SQL.Add(',Editer='''+Trim(DName)+'''');
    SQL.Add(',Edittime=getdate() ');
    SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
    
    SQL.Add('Update YF_Money_KC Set KCBBMoney=KCBBMoney+'+FKCBB+'-'+mvalue);
    sql.Add(' where CRID='''+Trim(CDS_HZ.fieldbyname('CRID').AsString)+'''');
    ExecSQL;
  end;
  try
    geteditRzhi();
    with ADOqueryCmd do
    begin
      Close;
      sql.Clear;
      SQL.Add('delete from YF_Money_LL where fromMainID='''+Trim(CDS_HZ.fieldbyname('YFID').AsString)+''' ');
      execsql;
    end;
    IF (CDS_HZ.FieldByName('money').AsFloat<>0) and
       (trim(CDS_HZ.fieldbyname('bankNo').AsString)<>'') then
    begin
      IF not saveZL() then
      begin
        application.MessageBox('˻ˮϢʧ','ʾϢ',0);
      end;
    end;
  except
  end;  }
end;

procedure TfrmFKCR.conNoChange(Sender: TObject);
begin
  if Length(Trim(conNo.Text))<3 then Exit;
  ToolButton2.Click;
end;

procedure TfrmFKCR.v2Column1PropertiesEditValueChanged(Sender: TObject);
var
  mvalue,FFieldName:String;
begin
  mvalue:=TcxTextEdit(Sender).EditingText;
  FFieldName:=Trim(Tv2.Controller.FocusedColumn.DataBinding.FilterFieldName);
  with CDS_HZ do
  begin
    Edit;
    FieldByName(FFieldName).Value:=Trim(mvalue);
    Post;
  end;
  with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add('UPdate YF_Money_CR ');
    sql.Add(' Set '+FFieldName+'='''+Trim(mvalue)+'''');
    SQL.Add(',Editer='''+Trim(DName)+'''');
    SQL.Add(',Edittime=getdate() ');
    SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
    ExecSQL;
  end;
end;

procedure TfrmFKCR.v2DerateMoneyPropertiesEditValueChanged(
  Sender: TObject);
var
  mvalue:string;
begin
  mvalue:=TcxTextEdit(Sender).EditingText;

  if Trim(mvalue)='' then mvalue:='0';
  with CDS_HZ do
  begin
    Edit;
    FieldByName('DerateMoney').Value:=StrToFloatdef(mvalue,0);
    Post;
  end;
{  with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add('UPdate YF_Money_CR ');
    sql.Add(' set DerateMoney='+mvalue);
    SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
    ExecSQL;
  end;
  }
end;


procedure TfrmFKCR.v2fstr1PropertiesEditValueChanged(Sender: TObject);
var
  mvalue:string;
begin
  mvalue:=TcxTextEdit(Sender).EditingText;

  with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add('UPdate YF_Money_CR ');
    sql.Add(' set fstr1='+quotedstr(trim(mvalue)));
    SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
    ExecSQL;
  end;
end;
procedure TfrmFKCR.v2Column2PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:=trim(fsyrName)+'XJLLFLAG';
      flagname:='˻Ͷ';
      if ShowModal=1 then
      begin
        with Self.CDS_HZ do
        begin
          Edit;
          FieldByName('bankNo').Value:=Trim(ClientDataSet1.fieldbyname('ZdyName').AsString);
        end;
       { with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('UPdate YF_Money_CR ');
          sql.Add(' Set bankNo='''+Trim(ClientDataSet1.fieldbyname('ZdyName').AsString)+'''');
          SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
          ExecSQL;
        end;  }
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
{  try
    geteditRzhi();
    with ADOqueryCmd do
    begin
      Close;
      sql.Clear;
      SQL.Add('delete from YF_Money_LL where fromMainID='''+Trim(CDS_HZ.fieldbyname('YFID').AsString)+''' ');
      execsql;
    end;
    IF (CDS_HZ.FieldByName('money').AsFloat<>0) and
       (trim(CDS_HZ.fieldbyname('bankNo').AsString)<>'') then
    begin
      IF not saveZL() then
      begin
        application.MessageBox('˻ˮϢʧ','ʾϢ',0);
      end;
    end;
  except
  end;  }
end;

procedure TfrmFKCR.ToolButton4Click(Sender: TObject);
begin
  frmSysLogHelp:=TfrmSysLogHelp.create(self);
  with frmSysLogHelp do
  begin
    facction:='Ǽ޸';
    showmodal;
    free;
  end;
end;

procedure TfrmFKCR.ToolButton5Click(Sender: TObject);
begin
 IF CDS_HZ.IsEmpty then exit;
 begdate.SetFocus;
  if CDS_HZ.Locate('ssel',true,[])=false then
  begin
    Application.MessageBox('ûѡ!','ʾ',0);
    Exit;
  end;

  try
    ADOQueryCmd.Connection.BeginTrans;
    with CDS_HZ do
    begin
      DisableControls;
      First;
      while not eof do
      begin
        IF Fieldbyname('ssel').AsBoolean then
        begin
          IF trim(fieldbyName('bankNo').AsString)='' then
          begin
            ADOQueryCmd.Connection.RollbackTrans;
            application.MessageBox('˻Ϊգ','ʾϢ',MB_ICONERROR);
            exit;
          end;
          with ADOQueryCmd do
          begin
            close;
            sql.Clear;
            sql.Add('UPdate YF_Money_CR SET ');
            sql.Add(' Money='''+floattostr(CDS_HZ.fieldbyname('Money').AsFloat)+''' ');
            sql.Add(',BBMoney='''+floattostr(CDS_HZ.fieldbyname('BBMoney').AsFloat)+''' ');
            sql.Add(',DerateMoney='''+floattostr(CDS_HZ.fieldbyname('DerateMoney').AsFloat)+''' ');
            sql.Add(',bankNo='''+trim(CDS_HZ.fieldbyname('bankNo').AsString)+''' ');
            sql.Add(',CRTime='''+formatdateTIme('yyyy-MM-dd',CDS_HZ.fieldbyname('CRTime').AsDateTime)+''' ');
            sql.Add(',Note='''+trim(CDS_HZ.fieldbyname('Note').AsString)+''' ');
            SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
            execsql;
          end;
          try
            geteditRzhi();
            with ADOqueryCmd do
            begin
              Close;
              sql.Clear;
              SQL.Add('delete from YF_Money_LL where fromMainID='''+Trim(CDS_HZ.fieldbyname('YFID').AsString)+''' ');
              execsql;
            end;
            IF (CDS_HZ.FieldByName('Money').AsFloat<>0) and
             (trim(CDS_HZ.fieldbyname('bankNo').AsString)<>'') then
            begin
              IF not saveZL() then
              begin
                application.MessageBox('˻ˮϢʧ','ʾϢ',0);
              end;
            end;
          except
          end;
        end;
        next;
      end;
      First;
      EnableControls;
    end;
    ADOQueryCmd.Connection.CommitTrans;
    //InitGrid();
  except
    ADOQueryCmd.Connection.RollbackTrans;
    application.MessageBox('ʧܣ','ʾϢ',0);
  end;
end;

procedure TfrmFKCR.CheckBox1Click(Sender: TObject);
begin
 IF  CDS_HZ.IsEmpty then exit;
  with CDS_HZ do
  begin
    DisableControls;
    first;
    while not eof do
    begin
      edit;
      fieldbyname('ssel').Value:=checkbox1.Checked;
      post;
      next;
    end;
    First;
    EnableControls;
  end;
end;

end.
