unit U_YFFKList;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxGraphics, cxCustomData, cxStyles, cxTL, cxMaskEdit, DB, ADODB,
  cxInplaceContainer, cxDBTL, cxControls, cxTLData, ComCtrls, ToolWin,
  StdCtrls, cxFilter, cxData, cxDataStorage, cxEdit, cxDBData, DBClient,
  cxGridCustomTableView, cxGridTableView, cxGridDBTableView, ExtCtrls,
  cxSplitter, cxGridLevel, cxClasses, cxGridCustomView, cxGrid,
  cxGridCustomPopupMenu, cxGridPopupMenu, RM_Dataset, RM_System, RM_Common,
  RM_Class, RM_GridReport, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient, IdFTP,ShellAPI,IniFiles, cxCheckBox, cxCalendar,
  cxButtonEdit, cxTextEdit;

type
  TfrmYFFKList = class(TForm)
    ToolBar1: TToolBar;
    TBRafresh: TToolButton;
    TBClose: TToolButton;
    ADOQueryTemp: TADOQuery;
    ADOQueryCmd: TADOQuery;
    Panel1: TPanel;
    ToolButton2: TToolButton;
    ADOQueryMain: TADOQuery;
    ToolButton1: TToolButton;
    RM1: TRMGridReport;
    RMDB_Main: TRMDBDataSet;
    Label3: TLabel;
    FactoryName: TEdit;
    cxGrid2: TcxGrid;
    Tv2: TcxGridDBTableView;
    cxGridLevel1: TcxGridLevel;
    Label2: TLabel;
    Label6: TLabel;
    begdate: TDateTimePicker;
    Enddate: TDateTimePicker;
    cxGridPopupMenu2: TcxGridPopupMenu;
    DS_HZ: TDataSource;
    CDS_HZ: TClientDataSet;
    v2Column5: TcxGridDBColumn;
    v2Column6: TcxGridDBColumn;
    v2Column1: TcxGridDBColumn;
    v2Column2: TcxGridDBColumn;
    v2Column3: TcxGridDBColumn;
    v2BQKP: TcxGridDBColumn;
    v2WKP: TcxGridDBColumn;
    v2GSTT: TcxGridDBColumn;
    Label1: TLabel;
    ComTaiTou: TEdit;
    v2Column4: TcxGridDBColumn;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure FactoryNameChange(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
  private
    { Private declarations }
    procedure InitGrid();
  public
    fDParameters1:string;
    { Public declarations }
    RKFlag,FCYID:String;

  end;

var
  frmYFFKList: TfrmYFFKList;

implementation
uses
  U_DataLink,U_Fun,U_ZDYHelp;

{$R *.dfm}



procedure TfrmYFFKList.InitGrid();
begin
  try
    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Filtered:=False;
      Close;
      SQL.Clear;
      if Trim(DParameters10)='' then
        sql.Add(' exec P_YFFK_List10 :begdate,:Enddate,:Flag')
      else
        SQL.Add(' exec '+Trim(DParameters10)+' :begdate,:Enddate');
      Parameters.ParamByName('begdate').Value:=Trim(FormatDateTime('yyyy-MM-dd',begdate.DateTime));
      Parameters.ParamByName('Enddate').Value:=Trim(FormatDateTime('yyyy-MM-dd',Enddate.DateTime+1));
      Parameters.ParamByName('Flag').Value:=Trim(fDParameters1);
      Open;
    end;
    SCreateCDS20(ADOQueryMain,CDS_HZ);
    SInitCDSData20(ADOQueryMain,CDS_HZ);
  finally
    ADOQueryMain.EnableControls;
  end;
end;


procedure TfrmYFFKList.FormDestroy(Sender: TObject);
begin
  frmYFFKList:=nil;
end;

procedure TfrmYFFKList.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TfrmYFFKList.TBCloseClick(Sender: TObject);
begin
  WriteCxGrid('Ӧͳ',Tv2,'');
  Close;
end;
procedure TfrmYFFKList.FormShow(Sender: TObject);
begin
  ReadCxGrid('Ӧͳ',Tv2,'');
  Enddate.DateTime:=SGetServerDate(ADOQueryTemp);
  begdate.DateTime:=Enddate.DateTime;
  if Trim(DParameters5)='Ʊ' then
  begin
    v2BQKP.Hidden:=False;
    v2BQKP.Visible:=True;
    v2WKP.Hidden:=False;
    v2WKP.Visible:=True;
  end else
  begin
    v2BQKP.Hidden:=True;
    v2BQKP.Visible:=False;
    v2WKP.Hidden:=True;
    v2WKP.Visible:=False;
  end;
  if Trim(DParameters9)='̨֧ͷ' then
  begin
    v2GSTT.Hidden:=False;
    v2GSTT.Visible:=True;
    Label1.Visible:=True;
    ComTaiTou.Visible:=True;
  end else
  begin
    v2GSTT.Hidden:=True;
    v2GSTT.Visible:=False;
    Label1.Visible:=False;
    ComTaiTou.Visible:=False;
  end;

  
  InitGrid();
end;

procedure TfrmYFFKList.TBRafreshClick(Sender: TObject);
begin
  InitGrid();
end;

procedure TfrmYFFKList.ToolButton2Click(Sender: TObject);
var
  fsj:string;
begin
  if ADOQueryMain.Active=False then Exit;
  SDofilter(ADOQueryMain,Trim(SGetFilters(Panel1,1,2)));
  SCreateCDS20(ADOQueryMain,CDS_HZ);
  SInitCDSData20(ADOQueryMain,CDS_HZ);
end;

procedure TfrmYFFKList.FactoryNameChange(Sender: TObject);
begin
  ToolButton2.Click;
end;

procedure TfrmYFFKList.ToolButton1Click(Sender: TObject);
begin
  if ADOQueryMain.IsEmpty then Exit;
  SelExportData(Tv2,ADOQueryMain,'Ӧͳб');
end;

end.
