unit U_CP_COL_XL_ZD;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, ToolWin, DBClient, DB, ADODB,
  cxStyles, cxCustomData, cxGraphics, cxFilter, cxData, cxDataStorage,
  cxEdit, cxDBData, cxGridCustomTableView, cxGridTableView,
  cxGridBandedTableView, cxGridDBBandedTableView, cxControls,
  cxGridCustomView, cxClasses, cxGridLevel, cxGrid, cxLookAndFeels,
  cxLookAndFeelPainters, cxNavigator;

type
  TfrmCP_COL_XL_ZD = class(TForm)
    ToolBar1: TToolBar;
    TBRafresh: TToolButton;
    TBFind: TToolButton;
    TBClose: TToolButton;
    Panel1: TPanel;
    Label1: TLabel;
    Label4: TLabel;
    Label9: TLabel;
    BegDate: TDateTimePicker;
    EndDate: TDateTimePicker;
    P_CodeName: TEdit;
    ConNoM: TEdit;
    Label2: TLabel;
    ADOQueryMain: TADOQuery;
    DS_Main: TDataSource;
    CDS_main: TClientDataSet;
    cxGrid1Level1: TcxGridLevel;
    cxGrid1: TcxGrid;
    Tv1: TcxGridDBBandedTableView;
    v1Column1: TcxGridDBBandedColumn;
    v1Column2: TcxGridDBBandedColumn;
    v1Column3: TcxGridDBBandedColumn;
    v1Column4: TcxGridDBBandedColumn;
    v1Column5: TcxGridDBBandedColumn;
    v1Column6: TcxGridDBBandedColumn;
    v1Column7: TcxGridDBBandedColumn;
    v1Column11: TcxGridDBBandedColumn;
    v1Column12: TcxGridDBBandedColumn;
    v1Column13: TcxGridDBBandedColumn;
    v1Column18: TcxGridDBBandedColumn;
    P_color: TEdit;
    Label3: TLabel;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure TBFindClick(Sender: TObject);
    procedure P_CodeNameChange(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    procedure InitGrid();
    { Private declarations }
  public
    canshu1:string;
    { Public declarations }
  end;

var
  frmCP_COL_XL_ZD: TfrmCP_COL_XL_ZD;

implementation
uses
  U_DataLink,U_Fun10;
{$R *.dfm}
procedure TfrmCP_COL_XL_ZD.InitGrid();
begin
  try
    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Close;
      Filtered:=False;
      sql.Clear;
      sql.Add(' exec P_Get_CP_col_Xl_ZD ');
      SQL.Add(' @begdate='''+FormatDateTime('yyyy-MM-dd',BegDate.DateTime)+'''');
      SQL.Add(',@enddate='''+FormatDateTime('yyyy-MM-dd',enddate.DateTime+1)+'''');
      Open;
    end;
    SCreateCDS20(ADOQueryMain,CDS_Main);
    SInitCDSData20(ADOQueryMain,CDS_Main);
  finally
    ADOQueryMain.EnableControls;
  end;
  TBfind.Click;
end;

procedure TfrmCP_COL_XL_ZD.FormDestroy(Sender: TObject);
begin
  frmCP_COL_XL_ZD:=nil;
end;

procedure TfrmCP_COL_XL_ZD.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:=cafree;
end;

procedure TfrmCP_COL_XL_ZD.FormCreate(Sender: TObject);
begin
  enddate.DateTime:=now();
  begdate.DateTime:=enddate.DateTime-30;
  cxGrid1.Align:=alclient;
  canshu1:=trim(DParameters1);
end;

procedure TfrmCP_COL_XL_ZD.TBCloseClick(Sender: TObject);
begin
  close;
end;

procedure TfrmCP_COL_XL_ZD.TBFindClick(Sender: TObject);
begin
  if ADOQueryMain.Active=False then Exit;
  SDofilter(ADOQueryMain,SGetFilters(Panel1,1,2));
  SCreateCDS20(ADOQueryMain,CDS_Main);
  SInitCDSData20(ADOQueryMain,CDS_Main);
end;

procedure TfrmCP_COL_XL_ZD.P_CodeNameChange(Sender: TObject);
begin
  TBfind.Click;
end;

procedure TfrmCP_COL_XL_ZD.TBRafreshClick(Sender: TObject);
begin
  initGrid();
end;

procedure TfrmCP_COL_XL_ZD.FormShow(Sender: TObject);
begin
  IF trim(canshu1)='𻪷֯'then
  begin
    tv1.Bands[2].Visible:=false;
    tv1.Bands[3].Visible:=false;
    tv1.Bands[4].Visible:=false;
  end;
  IF trim(canshu1)=''then
  begin
    tv1.Bands[1].Visible:=false;
    tv1.Bands[3].Visible:=false;
    tv1.Bands[4].Visible:=false;
  end;
end;

end.
