unit U_OldOrderNoInPut;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxStyles, cxCustomData, cxGraphics, cxFilter, cxData,
  cxDataStorage, cxEdit, DB, cxDBData, cxCalendar, cxDropDownEdit,
  ComCtrls, ToolWin, cxGridLevel, cxGridCustomTableView, cxGridTableView,
  cxGridDBTableView, cxClasses, cxControls, cxGridCustomView, cxGrid,
  cxGridCustomPopupMenu, cxGridPopupMenu, ADODB, DBClient, cxButtonEdit,
  cxTextEdit;

type
  TfrmOldOrderNoInPut = class(TForm)
    ToolBar1: TToolBar;
    TBAdd: TToolButton;
    TBDel: TToolButton;
    TBSave: TToolButton;
    TBClose: TToolButton;
    DataSource3: TDataSource;
    CDS_Sub: TClientDataSet;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    ADOQueryTemp: TADOQuery;
    cxGridPopupMenu2: TcxGridPopupMenu;
    cxGrid2: TcxGrid;
    Tv1: TcxGridDBTableView;
    v1Column6: TcxGridDBColumn;
    v1Column2: TcxGridDBColumn;
    v2Column3: TcxGridDBColumn;
    v1Column14: TcxGridDBColumn;
    v1Column1: TcxGridDBColumn;
    v2Column1: TcxGridDBColumn;
    v1Column7: TcxGridDBColumn;
    v1Column3: TcxGridDBColumn;
    v1Column5: TcxGridDBColumn;
    v1Column9: TcxGridDBColumn;
    v2Column6: TcxGridDBColumn;
    v1Column10: TcxGridDBColumn;
    v1Column11: TcxGridDBColumn;
    v1Column12: TcxGridDBColumn;
    cxGrid2Level1: TcxGridLevel;
    v1Column4: TcxGridDBColumn;
    v1Column13: TcxGridDBColumn;
    ADOQuery1: TADOQuery;
    v1Column8: TcxGridDBColumn;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TBAddClick(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBDelClick(Sender: TObject);
    procedure TBSaveClick(Sender: TObject);
    procedure v1Column3PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v1Column14PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v2Column1PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure Tv1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure v1Column8PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
  private
    { Private declarations }
    function SaveCKData():Boolean;
  public
    { Public declarations }
    FBCId:String;
  end;

var
  frmOldOrderNoInPut: TfrmOldOrderNoInPut;

implementation
uses
  U_DataLink,U_RTFun,U_ClothContractListHZCX,U_ZDYHelp, U_GYSSelList;

{$R *.dfm}

procedure TfrmOldOrderNoInPut.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TfrmOldOrderNoInPut.TBAddClick(Sender: TObject);
begin
  with CDS_Sub do
  begin
    Append;
    FieldByName('CRTime').Value:=Trim(FormatDateTime('yyyy-MM-dd',Now));
    Post;
  end;
end;
function TfrmOldOrderNoInPut.SaveCKData():Boolean;
var
  FCRID,Maxno:string;
begin
  try
    ADOQueryCmd.Connection.BeginTrans;
    CDS_Sub.DisableControls;
    with CDS_Sub do
    begin
      First;
      while not eof do
      begin
        
        if Trim(CDS_Sub.fieldbyname('SPID').AsString)<>'' then
        begin
          with ADOQuery1 do
          begin
            Close;
            sql.Clear;
            sql.Add('select * from CK_SXPB_CR where SPID='''+Trim(CDS_Sub.fieldbyname('SPID').AsString)+'''');
            Open;
          end;
          if ADOQuery1.IsEmpty then
          begin
            with ADOQueryTemp do
            begin
              Close;
              sql.Clear;
              sql.Add('select * from CK_SXPB_CRID');
              Open;
            end;
            if ADOQueryTemp.IsEmpty then
            begin
              with ADOQueryCmd do
              begin
                Close;
                sql.Clear;
                sql.Add('insert into CK_SXPB_CRID select 0');
                sql.Add(' select * from CK_SXPB_CRID');
                Open;
              end;
              FCRID:=Trim(ADOQueryCmd.fieldbyname('CRID').AsString);
            end else
            begin
              with ADOQueryCmd do
              begin
                Close;
                sql.Clear;
                sql.Add('Update CK_SXPB_CRID Set CRID=CRID+1');
                sql.Add(' select * from CK_SXPB_CRID');
                Open;
              end;
              FCRID:=Trim(ADOQueryCmd.fieldbyname('CRID').AsString);
            end;
          end else
          begin
            FCRID:=Trim(ADOQuery1.fieldbyname('CRID').AsString);
          end;
        end else
        begin
          with ADOQueryTemp do
          begin
            Close;
            sql.Clear;
            sql.Add('select * from CK_SXPB_CRID');
            Open;
          end;
          if ADOQueryTemp.IsEmpty then
          begin
            with ADOQueryCmd do
            begin
              Close;
              sql.Clear;
              sql.Add('insert into CK_SXPB_CRID select 0');
              sql.Add(' select * from CK_SXPB_CRID');
              Open;
            end;
            FCRID:=Trim(ADOQueryCmd.fieldbyname('CRID').AsString);
          end else
          begin
            with ADOQueryCmd do
            begin
              Close;
              sql.Clear;
              sql.Add('Update CK_SXPB_CRID Set CRID=CRID+1');
              sql.Add(' select * from CK_SXPB_CRID');
              Open;
            end;
            FCRID:=Trim(ADOQueryCmd.fieldbyname('CRID').AsString);
          end;
        end;
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('select * from CK_SXPB_KC where CRID='+FCRID);
          Open;
        end;
        with ADOQueryCmd do
        begin
          with ADOQueryTemp do
          begin
            Close;
            sql.Clear;
            sql.Add('select * from CK_SXPB_CR where SPID='''+Trim(CDS_Sub.fieldbyname('SPID').AsString)+'''');
            Open;
          end;
          if ADOQueryTemp.IsEmpty then
          begin
            Append;
          end else
          begin
            Edit;
          end;
          FieldByName('CRID').Value:=FCRID;
          FieldByName('CKName').Value:='ϵ';
          FieldByName('BatchNo').Value:=CDS_Sub.fieldbyname('BatchNo').Value;
          FieldByName('SPType').Value:=CDS_Sub.fieldbyname('SPType').Value;
          FieldByName('FactoryName').Value:=CDS_Sub.fieldbyname('FactoryName').Value;
          FieldByName('FactoryNo').Value:=CDS_Sub.fieldbyname('FactoryNo').Value;
          FieldByName('SPName').Value:=CDS_Sub.fieldbyname('SPName').Value;
          FieldByName('SPSpec').Value:=CDS_Sub.fieldbyname('SPSpec').Value;
          FieldByName('SPMF').Value:=CDS_Sub.fieldbyname('SPMF').Value;
          FieldByName('SPKZ').Value:=CDS_Sub.fieldbyname('SPKZ').Value;
          FieldByName('SPColor').Value:=CDS_Sub.fieldbyname('SPColor').Value;
          FieldByName('SPHX').Value:=CDS_Sub.fieldbyname('SPHX').Value;
          FieldByName('KCNote').Value:=CDS_Sub.fieldbyname('Note').Value;
          Post;
        end;

        if Trim(CDS_Sub.fieldbyname('SPID').AsString)='' then
        begin
          if GetLSNo(ADOQueryCmd,Maxno,'OR','CK_SXPB_CR',3,1)=False then
          begin
            Result:=False;
            ADOQueryCmd.Connection.RollbackTrans;
            Application.MessageBox('ȡʧ!','ʾ',0);
            Exit;
          end;
        end else
        begin
          Maxno:=Trim(CDS_Sub.fieldbyname('SPID').AsString);
        end;
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('select * from CK_SXPB_CR where SPID='''+Trim(Maxno)+'''');
          Open;
        end;
        with ADOQueryCmd do
        begin
          with ADOQueryTemp do
          begin
            Close;
            sql.Clear;
            sql.Add('select * from CK_SXPB_CR where SPID='''+Trim(CDS_Sub.fieldbyname('SPID').AsString)+'''');
            Open;
          end;
          if ADOQueryTemp.IsEmpty then
          begin
            Append;
          end else
          begin
            Edit;
          end;
          {if Trim(CDS_Sub.fieldbyname('SPID').AsString)='' then
          begin
            Append;
          end else
          begin
            Edit;
          end;  }
          FieldByName('SPID').Value:=Trim(Maxno);
          FieldByName('CKName').Value:='ϵ';
          FieldByName('FactoryNo').Value:=Trim(CDS_Sub.fieldbyname('FactoryNo').AsString);
          FieldByName('CRFlag').Value:='';
          FieldByName('CRType').Value:='';
          FieldByName('CRQtyFlag').Value:=1;
          FieldByName('CRID').Value:=FCRID;
          RTSetSaveDataCDS(ADOQueryCmd,Tv1,CDS_Sub,'CK_SX_CR',2);
          with ADOQueryTemp do
          begin
            Close;
            sql.Clear;
            sql.Add('select * from CK_SXPB_CR where SPID='''+Trim(CDS_Sub.fieldbyname('SPID').AsString)+'''');
            Open;
          end;
          if ADOQueryTemp.IsEmpty then
          begin
            FieldByName('Filler').Value:=Trim(DName);
          end else
          begin
            FieldByName('Editer').Value:=Trim(DName);
            FieldByName('EditTime').Value:=SGetServerDate(ADOQueryTemp);
          end;
          Post;
        end;
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('Update CK_SXPB_KC Set KCQty=(select sum(isnull(Qty,0)*CRQtyFlag) from CK_SXPB_CR A where A.CRID=CK_SXPB_KC.CRID)');
          sql.Add(',KCPiQty=(select sum(isnull(PiQty,0)*CRQtyFlag) from CK_SXPB_CR A where A.CRID=CK_SXPB_KC.CRID)');
          sql.Add(' where CRID='+FCRID);
          ExecSQL;
        end;
        with ADOQueryTemp do
        begin
          Close;
          sql.Clear;
          sql.Add('select * from CK_SXPB_KC where CRID='+Trim(FCRID));
          Open;
        end;
        if ADOQueryTemp.FieldByName('KCQty').Value<0 then
        begin
          CDS_Sub.DisableControls;
          ADOQueryCmd.Connection.RollbackTrans;
          Application.MessageBox('Сڳܱ!','ʾ',0);
          Exit;
        end;
       { if ADOQueryTemp.FieldByName('KCKeQty').Value<0 then
        begin
          CDS_Sub.DisableControls;
          ADOQueryCmd.Connection.RollbackTrans;
          Application.MessageBox('Сڳܱ!','ʾ',0);
          Exit;
        end; }
        Edit;
        FieldByName('SPID').Value:=Trim(Maxno);
        FieldByName('CRID').Value:=Trim(FCRID);
        Post;
        Next;
      end;
    end;
    CDS_Sub.EnableControls;
    ADOQueryCmd.Connection.CommitTrans;
    Result:=True;
  except
    Result:=False;
    ADOQueryCmd.Connection.RollbackTrans;
    Application.MessageBox('쳣!','ʾ',0);
  end;

end;
procedure TfrmOldOrderNoInPut.TBCloseClick(Sender: TObject);
begin
  WriteCxGrid('ϵǼ',Tv1,'ϵŲֿ');
  Close;
end;

procedure TfrmOldOrderNoInPut.FormShow(Sender: TObject);
var
  fsj:String;
begin
  ReadCxGrid('ϵǼ',Tv1,'ϵŲֿ');
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add(' select A.* ');
    sql.Add(' from CK_SXPB_CR A');
    sql.Add(' where SPID='''+Trim(FBCId)+'''');
    Open;
  end;
  SCreateCDS20(ADOQueryTemp,CDS_Sub);
  SInitCDSData20(ADOQueryTemp,CDS_Sub);
end;

procedure TfrmOldOrderNoInPut.TBDelClick(Sender: TObject);
begin
  if CDS_Sub.IsEmpty then Exit;
  if Trim(CDS_Sub.fieldbyname('SPID').AsString)<>'' then
  begin
    if Application.MessageBox('ȷҪɾ','ʾ',32+4)<>IDYES then Exit;
    try
      ADOQueryCmd.Connection.BeginTrans;
      with ADOQueryCmd do
      begin
        Close;
        sql.Clear;
        sql.Add(' delete CK_SXPB_CR where SPID='''+Trim(CDS_Sub.fieldbyname('SPID').AsString)+'''');
        sql.Add('Update CK_SXPB_KC Set KCQty=(select sum(isnull(Qty,0)*CRQtyFlag) from CK_SXPB_CR A where A.CRID=CK_SXPB_KC.CRID)');
        sql.Add(',KCPiQty=(select sum(isnull(PiQty,0)*CRQtyFlag) from CK_SXPB_CR A where A.CRID=CK_SXPB_KC.CRID)');
        sql.Add(' where CRID='+Trim(CDS_Sub.fieldbyname('CRID').AsString));
        ExecSQL;
      end;
      with ADOQueryTemp do
      begin
        Close;
        sql.Clear;
        sql.Add('select * from CK_SXPB_KC where CRID='+Trim(CDS_Sub.fieldbyname('CRID').AsString));
        Open;
      end;
      if ADOQueryTemp.FieldByName('KCQty').Value<0 then
      begin
        ADOQueryCmd.Connection.RollbackTrans;
        Application.MessageBox('Сڳɾ!','ʾ',0);
        Exit;
      end;
      ADOQueryCmd.Connection.CommitTrans;
      CDS_Sub.Delete;
    except
      ADOQueryCmd.Connection.RollbackTrans;
      Application.MessageBox('ɾ쳣!','ʾ',0);
    end;

  end else
  begin
    CDS_Sub.Delete;
  end;

end;

procedure TfrmOldOrderNoInPut.TBSaveClick(Sender: TObject);
begin
  if CDS_Sub.IsEmpty then Exit;
  if CDS_Sub.Locate('CRTime',null,[])=True then
  begin
    Application.MessageBox('ʱ䲻Ϊ!','ʾ',0);
    Exit;
  end;
   if CDS_Sub.Locate('BatchNo',null,[])=True then
  begin
    Application.MessageBox('ŲΪ!','ʾ',0);
    Exit;
  end;
  if CDS_Sub.Locate('SPName',null,[])=True then
  begin
    Application.MessageBox('ƷΪ!','ʾ',0);
    Exit;
  end;
  if CDS_Sub.Locate('SPType',null,[])=True then
  begin
    Application.MessageBox('ƥͲΪ!','ʾ',0);
    Exit;
  end;
  if CDS_Sub.Locate('SPMF',null,[])=True then
  begin
    Application.MessageBox('ŷΪ!','ʾ',0);
    Exit;
  end;
  if CDS_Sub.Locate('SPKZ',null,[])=True then
  begin
    Application.MessageBox('زΪ!','ʾ',0);
    Exit;
  end;
  if CDS_Sub.Locate('FactoryName',null,[])=True then
  begin
    Application.MessageBox('Ӧ̲Ϊ!','ʾ',0);
    Exit;
  end;
  if CDS_Sub.Locate('PiQty',null,[])=True then
  begin
    Application.MessageBox('ƥΪ!','ʾ',0);
    Exit;
  end;
  if CDS_Sub.Locate('Qty',null,[])=True then
  begin
    Application.MessageBox('Ϊ!','ʾ',0);
    Exit;
  end;
  if CDS_Sub.Locate('QtyUnit',null,[])=True then
  begin
    Application.MessageBox('λΪ!','ʾ',0);
    Exit;
  end;
  {if CDS_Sub.Locate('CostPrice',null,[])=True then
  begin
    Application.MessageBox('ɱΪ!','ʾ',0);
    Exit;
  end;
  if CDS_Sub.Locate('CRType;Price',VarArrayOf(['',Null]),[loPartialKey])=True then
  begin
    Application.MessageBox('ݣɹӹ۲Ϊ!','ʾ',0);
    Exit;
  end;}
  if SaveCKData() then
  begin
    Application.MessageBox('ɹ!','ʾ',0);
    //ModalResult:=1;
    Exit;
  end;
end;

procedure TfrmOldOrderNoInPut.v1Column3PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='SXKuWei';
      flagname:='λ';
      if ShowModal=1 then
      begin
        with Self.CDS_Sub do
        begin
          Edit;
          FieldByName('KuWei').Value:=Trim(frmZDYHelp.ClientDataSet1.fieldbyname('ZdyName').AsString);
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmOldOrderNoInPut.v1Column14PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmGYSSelList:=TfrmGYSSelList.Create(Application);
    with frmGYSSelList do
    begin
      if ShowModal=1 then
      begin
        with Self.CDS_Sub do
        begin
          edit;
          FieldByName('FactoryNo').Value:=Trim(frmGYSSelList.Order_Main.fieldbyname('ZKID').AsString) ;
          FieldByName('FactoryName').Value:=Trim(frmGYSSelList.Order_Main.fieldbyname('KHNameJC').AsString);
          //Post;
        end;
      end;
    end;
  finally
    frmGYSSelList.Free;
  end;
end;

procedure TfrmOldOrderNoInPut.v2Column1PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='CPPBName';
      flagname:='ƥ';
      if ShowModal=1 then
      begin
        with Self.CDS_Sub do
        begin
          Edit;
          FieldByName('SPName').Value:=Trim(frmZDYHelp.ClientDataSet1.fieldbyname('ZdyName').AsString);
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmOldOrderNoInPut.Tv1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if CDS_Sub.IsEmpty then Exit;
  if Trim(CDS_Sub.fieldbyname('SPID').AsString)<>'' then
  begin
    v2Column3.Options.Focusing:=False;
  end else
  begin
    v2Column3.Options.Focusing:=True;
  end;
end;

procedure TfrmOldOrderNoInPut.v1Column8PropertiesButtonClick(
  Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='CPKuWei';
      flagname:='ϵſλ';
      if ShowModal=1 then
      begin
        with Self.CDS_Sub do
        begin
          Edit;
          FieldByName('KuWei').Value:=Trim(frmZDYHelp.ClientDataSet1.fieldbyname('ZdyName').AsString);
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

end.
