unit U_ProductOrderNewListXH;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, ToolWin, cxStyles, cxCustomData,
  cxGraphics, cxFilter, cxData, cxDataStorage, cxEdit, DB, cxDBData, ADODB,
  cxGridCustomPopupMenu, cxGridPopupMenu, cxGridLevel, cxClasses,
  cxControls, cxGridCustomView, cxGridCustomTableView, cxGridTableView,
  cxGridDBTableView, cxGrid, DBClient, cxCheckBox, cxCalendar, cxSplitter,
  RM_Dataset, RM_System, RM_Common, RM_Class, RM_GridReport, RM_e_Xls,
  Menus, cxPC, cxCurrencyEdit, BtnEdit, cxLookAndFeels,
  cxLookAndFeelPainters, cxNavigator, dxBarBuiltInMenu;

type
  TfrmProductOrderNewListXH = class(TForm)
    ToolBar1: TToolBar;
    TBRafresh: TToolButton;
    TBFind: TToolButton;
    TBAdd: TToolButton;
    TBEdit: TToolButton;
    TBDel: TToolButton;
    TBPrint: TToolButton;
    TBClose: TToolButton;
    Panel1: TPanel;
    BegDate: TDateTimePicker;
    EndDate: TDateTimePicker;
    Label1: TLabel;
    Tv1: TcxGridDBTableView;
    cxGrid1Level1: TcxGridLevel;
    cxGrid1: TcxGrid;
    cxGridPopupMenu1: TcxGridPopupMenu;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    ADOQueryTemp: TADOQuery;
    DataSource1: TDataSource;
    Label3: TLabel;
    OrderNo: TEdit;
    TBExport: TToolButton;
    v1OrderNo: TcxGridDBColumn;
    v1OrdDate: TcxGridDBColumn;
    v1DeliveryDate: TcxGridDBColumn;
    v1ConNo: TcxGridDBColumn;
    Order_Main: TClientDataSet;
    RM1: TRMGridReport;
    RMDBMain: TRMDBDataSet;
    RMXLSExport1: TRMXLSExport;
    v1CustomerNoName: TcxGridDBColumn;
    Label4: TLabel;
    CustomerNoName: TEdit;
    v1MPRTCodeName: TcxGridDBColumn;
    v1PRTOrderQty: TcxGridDBColumn;
    PopupMenu1: TPopupMenu;
    N2: TMenuItem;
    ToolButton1: TToolButton;
    Label2: TLabel;
    JGFactoryName: TEdit;
    Label5: TLabel;
    OrdPerson1: TEdit;
    Label8: TLabel;
    PRTCodeName: TEdit;
    Label9: TLabel;
    ConNo: TEdit;
    v1Column8: TcxGridDBColumn;
    Label11: TLabel;
    OrdDefStr1: TEdit;
    ToolButton2: TToolButton;
    ADOQueryPrint: TADOQuery;
    CDS_Print: TClientDataSet;
    ToolButton3: TToolButton;
    v1Column4: TcxGridDBColumn;
    v1Column1: TcxGridDBColumn;
    v1Column2: TcxGridDBColumn;
    v1Column3: TcxGridDBColumn;
    v1Column5: TcxGridDBColumn;
    cxTabControl1: TcxTabControl;
    tchk: TToolButton;
    tNochk: TToolButton;
    v1EditTime: TcxGridDBColumn;
    v1ordderNote1: TcxGridDBColumn;
    v1Column6: TcxGridDBColumn;
    v1Column7: TcxGridDBColumn;
    v1Column9: TcxGridDBColumn;
    v1Column10: TcxGridDBColumn;
    v1Column11: TcxGridDBColumn;
    v1Column12: TcxGridDBColumn;
    v1Column13: TcxGridDBColumn;
    v1Column14: TcxGridDBColumn;
    TBPrint1: TToolButton;
    v1Column17: TcxGridDBColumn;
    v1Filler: TcxGridDBColumn;
    v1Column18: TcxGridDBColumn;
    PrtColor: TEdit;
    Label6: TLabel;
    orderType: TComboBox;
    Label24: TLabel;
    TBPrint2: TToolButton;
    v1Column15: TcxGridDBColumn;
    v1Column16: TcxGridDBColumn;
    Panel2: TPanel;
    Label7: TLabel;
    Label10: TLabel;
    Button1: TButton;
    Button2: TButton;
    cust: TBtnEditA;
    cxGrid2: TcxGrid;
    TV3: TcxGridDBTableView;
    V3Column1: TcxGridDBColumn;
    V3Column2: TcxGridDBColumn;
    V3Column3: TcxGridDBColumn;
    cxGrid2Level1: TcxGridLevel;
    Button3: TButton;
    TBcust: TToolButton;
    CDSPrice: TClientDataSet;
    DSPrice: TDataSource;
    Trz: TToolButton;
    v1Column19: TcxGridDBColumn;
    C_CodeNameZW: TEdit;
    Label12: TLabel;
    ADOPrint: TADOQuery;
    RMDB_Main: TRMDBDataSet;
    RMDB_MD: TRMDBDataSet;
    ToolButton4: TToolButton;
    v1Column20: TcxGridDBColumn;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure TBFindClick(Sender: TObject);
    procedure TBEditClick(Sender: TObject);
    procedure TBDelClick(Sender: TObject);
    procedure TBExportClick(Sender: TObject);
    procedure TBPrintClick(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure TBAddClick(Sender: TObject);
    procedure OrderNoChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Tv1CellDblClick(Sender: TcxCustomGridTableView;
      ACellViewInfo: TcxGridTableDataCellViewInfo; AButton: TMouseButton;
      AShift: TShiftState; var AHandled: Boolean);
    procedure TBTPClick(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure Tv1StylesGetContentStyle(Sender: TcxCustomGridTableView;
      ARecord: TcxCustomGridRecord; AItem: TcxCustomGridTableItem;
      out AStyle: TcxStyle);
    procedure v1DeliveryDateCustomDrawCell(Sender: TcxCustomGridTableView;
      ACanvas: TcxCanvas; AViewInfo: TcxGridTableDataCellViewInfo;
      var ADone: Boolean);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure OrderNoKeyPress(Sender: TObject; var Key: Char);
    procedure ConNoKeyPress(Sender: TObject; var Key: Char);
    procedure tchkClick(Sender: TObject);
    procedure tNochkClick(Sender: TObject);
    procedure cxTabControl1Change(Sender: TObject);
    procedure TBPrint1Click(Sender: TObject);
    procedure Tv1CustomDrawCell(Sender: TcxCustomGridTableView;
      ACanvas: TcxCanvas; AViewInfo: TcxGridTableDataCellViewInfo;
      var ADone: Boolean);
    procedure TBPrint2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure TBcustClick(Sender: TObject);
    procedure custBtnClick(Sender: TObject);
    procedure TrzClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
  private
    DQdate:TDateTime;
    procedure InitGrid();
    procedure InitForm();
    function  DelData():Boolean;
    procedure SetStatus();
        { Private declarations }
  public
    FFInt,FCloth:Integer;
    fDParameters1:string;
    fCustomerNoName:string;
    forderType:string;
    fsyrName:string;
        { Public declarations }
  end;

var
  frmProductOrderNewListXH: TfrmProductOrderNewListXH;

implementation
uses
  U_DataLink,U_Fun, U_OrderInPut, U_ZdyAttachment, U_SysLogHelp;

{$R *.dfm}
procedure TfrmProductOrderNewListXH.SetStatus();
begin
  Tchk.Visible:=false;
  tNochk.Visible:=false;
  TBEdit.Enabled:=false;
  TBDel.Enabled:=false;
  TBPrint.Visible:=false;
  TBPrint1.Visible:=false;
  tbPrint2.Visible:=false;
  tbcust.Visible:=false;

  IF Trim(fDParameters1)='' then
  begin
    TBADD.Visible:=false;
    case cxTabControl1.TabIndex of
       0:begin

           TBEdit.Enabled:=true;
           Tchk.Visible:=true;
           TBDel.Enabled:=true;
         end;
       1:begin
           tNochk.Visible:=true;
           IF fOrderType='' then
           TBPrint1.Visible:=true
           else
           begin
           TBPrint.Visible:=true;
           end;
         //  tbPrint2.Visible:=true;
         end;
    end;
  end
  else
  IF Trim(fDParameters1)='' then
  begin
      TBADD.Visible:=false;
    case cxTabControl1.TabIndex of
       0:begin
           TBEdit.Enabled:=true;
           Tchk.Visible:=true;
           TBDel.Enabled:=true;
         end;
       1:begin
           tNochk.Visible:=true;
           IF fOrderType='' then
           TBPrint1.Visible:=true
           else
           begin
           TBPrint.Visible:=true;
           end;
      //     tbPrint2.Visible:=true;
         end;
    end;
  end
  else
  begin
    case cxTabControl1.TabIndex of
       0:begin
           TBEdit.Enabled:=true;
         //  Tchk.Visible:=true;
           TBDel.Enabled:=true;
         //  tbcust.Visible:=true;
         end;
       1:begin
           tbcust.Visible:=true;
           IF fOrderType='' then
           TBPrint1.Visible:=true
           else
           begin
           TBPrint.Visible:=true;
           end;
         end;
    end;
  end;

end;

procedure TfrmProductOrderNewListXH.FormDestroy(Sender: TObject);
begin
  frmProductOrderNewListXH:=nil;
end;

procedure TfrmProductOrderNewListXH.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TfrmProductOrderNewListXH.FormCreate(Sender: TObject);
begin
  cxgrid1.Align:=alClient;
end;

procedure TfrmProductOrderNewListXH.TBCloseClick(Sender: TObject);
begin
  Close;
  WriteCxGrid('ָʾбѡJW',Tv1,'ָʾ');
end;

procedure TfrmProductOrderNewListXH.InitGrid();
var
  strwhere:string;
begin
  strwhere:='';

  if cxTabControl1.TabIndex<2 then
  strwhere:=strwhere+' and isnull(B.status,''0'')='''+inttostr(cxTabControl1.TabIndex)+'''';

  if (trim(fDParameters1)<>'') and (trim(fDParameters1)<>'') then
  strwhere:=strwhere+' and  B.Filler='''+Trim(DName)+''' ';

  strwhere:=strwhere+' and  B.orderType='''+Trim(forderType)+'''';

  If trim(fsyrName)<>'' then
  begin
     strwhere:=strwhere+' and  B.syrName='''+Trim(fsyrName)+'''';
  end
  else
  begin
    strwhere:=strwhere+' and  B.syrName<>''˷֯''';
  end;

  try
    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Close;
      Filtered:=False;
      sql.Clear;
      sql.add('exec P_View_order :begdate,:enddate,:WSql') ;
      parameters.ParamByName('WSql').Value:=strwhere;
      Parameters.ParamByName('begdate').Value:=FormatDateTime('yyyy-MM-dd',BegDate.DateTime);
      Parameters.ParamByName('enddate').Value:=FormatDateTime('yyyy-MM-dd',enddate.DateTime+1);
      ExecSQL;
      Open;
    end;
    SCreateCDS20(ADOQueryMain,Order_Main);
    SInitCDSData20(ADOQueryMain,Order_Main);
  finally
    ADOQueryMain.EnableControls;
    TBFind.Click;
  end;
end;


procedure TfrmProductOrderNewListXH.InitForm();
begin

  if FCloth<>1 then
    ReadCxGrid('ָʾб10JW',Tv1,'ָʾ')
  else
    ReadCxGrid('ָʾбѡJW',Tv1,'ָʾ');

  if FCloth=1 then
  begin
    v1Column4.Visible:=True;

  end else
  begin
    v1Column4.Visible:=False;
  end;

  EndDate.DateTime:=SGetServerDate10(ADOQueryTemp);
  BegDate.DateTime:=EndDate.DateTime;

  InitGrid();
end;

procedure TfrmProductOrderNewListXH.TBFindClick(Sender: TObject);
begin
  if ADOQueryMain.Active=False then Exit;
  SDofilter(ADOQueryMain,SGetFilters(Panel1,1,2));
  SCreateCDS20(ADOQueryMain,Order_Main);
  SInitCDSData20(ADOQueryMain,Order_Main);
end;

procedure TfrmProductOrderNewListXH.TBEditClick(Sender: TObject);
begin
  if Order_Main.IsEmpty then Exit;
{  if Trim(Order_Main.fieldbyname('Filler').AsString)<>Trim(DName) then
  begin
    Application.MessageBox('ܲ˵!','ʾ',0);
    Exit;
  end;  }
  try
    frmOrderInPut:=TfrmOrderInPut.Create(Application);
    with frmOrderInPut do
    begin
            forderType:=self.forderType;
      PState:=1;
      FMainId:=Trim(Self.Order_Main.fieldbyname('MainId').AsString);
      FOrderNo:=Trim(Self.Order_Main.fieldbyname('OrderNo').AsString);
      fsyrName:=self.fsyrName;
      if ShowModal=1 then
      begin
        TBRafresh.Click;
      end;
    end;
  finally
    frmOrderInPut.Free;
  end;
end;

procedure TfrmProductOrderNewListXH.TBDelClick(Sender: TObject);
begin
  if Order_Main.IsEmpty then Exit;


  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    SQL.Add('select * from CK_BanCP_CR A   ');
    SQL.Add(' where MainId='''+Trim(Order_Main.fieldbyname('MainId').AsString)+'''');
    Open;
  end;
  if not ADOQueryTemp.IsEmpty then
  begin
    Application.MessageBox('Ѳ,ɾ!','ʾ',0);
    Exit;
  end;

  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    SQL.Add('select * from CK_BanCP_PH A   ');
    SQL.Add(' where MainId='''+Trim(Order_Main.fieldbyname('MainId').AsString)+'''');
    Open;
  end;
  if not ADOQueryTemp.IsEmpty then
  begin
    Application.MessageBox('Ѳ,ɾ!','ʾ',0);
    Exit;
  end;
{  if Trim(Order_Main.fieldbyname('Filler').AsString)<>Trim(DName) then
  begin
    Application.MessageBox('ܲ˵!','ʾ',0);
    Exit;
  end;
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    SQL.Add('select * from Contract_Cloth_LL A where exists (select * from JYOrder_Sub B where B.SubId=A.OrdSubId  ');
    SQL.Add(' and B.MainId='''+Trim(Order_Main.fieldbyname('MainId').AsString)+''')');
    Open;
  end;
  if ADOQueryTemp.IsEmpty=False then
  begin
    Application.MessageBox('Ѳݲɾ!','ʾ',0);
    Exit;
  end;
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add('select * from YF_Money_CR where MainId='''+Trim(Order_Main.fieldbyname('MainId').AsString)+'''');
    Open;
  end;
  if ADOQueryTemp.IsEmpty=False then
  begin
    Application.MessageBox('Ѳݲɾ!','ʾ',0);
    Exit;
  end;
  {with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add('select * from Contract_Cloth_LLMX where OrdSubId='''+Trim(Order_Main.fieldbyname('SubId').AsString)+'''');
    Open;
  end;
  if ADOQueryTemp.IsEmpty=False then
  begin
    Application.MessageBox('ϲɾ!','ʾ',0);
    Exit;
  end; }
{  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add('select * from JYOrder_Sub_AnPai where MainId='''+Trim(Order_Main.fieldbyname('MainId').AsString)+'''');
    Open;
  end;
  if ADOQueryTemp.IsEmpty=False then
  begin
    Application.MessageBox('ѻزֲɾ!','ʾ',0);
    Exit;
  end;              }
  if Application.MessageBox('ȷҪɾ','ʾ',32+4)<>IDYES then Exit;
  if DelData() then
  begin
    TBRafresh.Click;
  end;
end;

function TfrmProductOrderNewListXH.DelData():Boolean;
begin
  try
    Result:=false;
    ADOQueryCmd.Connection.BeginTrans;
    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add('delete JYOrder_Main where MainId='''+Trim(Order_Main.fieldbyname('MainId').AsString)+'''');
      sql.Add('delete JYOrder_Sub where MainId='''+Trim(Order_Main.fieldbyname('MainId').AsString)+'''');
      sql.Add('insert into SY_SysLog(operor,opertime,Model,acction,opevent,result) values( ');
      sql.Add(' '+quotedstr(trim(DName)));
      sql.Add(',getdate() ');
      sql.Add(','+quotedstr(trim(self.Caption)));
      sql.Add(','+quotedstr(trim('ָʾɾ')));
      sql.Add(','+quotedstr(trim('ţ'+trim(Order_Main.FieldByName('orderNo').AsString))));
      sql.Add(','+quotedstr(trim('ɹ')));
      sql.Add(')');

      ExecSQL;
    end;
    ADOQueryCmd.Connection.CommitTrans;
    Result:=True;
  except
    ADOQueryCmd.Connection.RollbackTrans;
    Result:=False;
    Application.MessageBox('ɾ쳣','ʾ',0);
  end;
end;

procedure TfrmProductOrderNewListXH.TBExportClick(Sender: TObject);
begin
  if ADOQueryMain.IsEmpty then Exit;
  SelExportData(Tv1,ADOQueryMain,'ָʾб');
end;

procedure TfrmProductOrderNewListXH.TBPrintClick(Sender: TObject);
var
   fPrintFile:string;
   Porderno,PRTCodeName,funit:string;
   i,j,k:Integer;
   Txt,fImagePath:string;
   Moudle: THandle;
   Makebar:TMakebar;
   Mixtext:TMixtext;
begin
  if Order_Main.IsEmpty then Exit;
   fPrintFile:= ExtractFilePath(Application.ExeName) + 'Report\ָʾ.rmf' ;

  with ADOQueryPrint do
  begin
    Close;
    sql.Clear;
    sql.Add('select *,KCNUm=(case when syrName<>''𻪷֯'' then (select sum(kcRollNum) from CK_BanCP_KC1 X where X.C_CodeName=A.prtCodeName and x.KCQty>0 and X.C_Color = A.PrtColor AND x.CPType not in(''һȴƷ'',''ȴƷ'')) ');
    sql.Add(' else (select sum(kcRollNum) from CK_BanCP_KC X where X.C_CodeName=A.prtCodeName and x.KCQty>0 and X.C_Color = A.PrtColor AND x.CPType not in(''һȴƷ'',''ȴƷ'')) end), ');
    sql.Add(' tyb=(select Top 1 defstr8 from KH_Zdy_Attachment X where X.zdyName=B.customerNoName and X.Type=''KHName''),');
    sql.Add(' tybTel=(select Top 1 DEFNote3  from KH_Zdy_Attachment X where X.zdyName=B.customerNoName and X.Type=''KHName''), ');
    sql.Add(' LXTel=(select Top 1 defstr1  from KH_Zdy_Attachment X where X.zdyName=B.customerNoName and X.Type=''KHName''), ');
  //  sql.Add(' kw2=(select Top 1 defstr5  from KH_Zdy_Attachment X where X.zdyName=A.prtCodeName and X.defstr3 = A.PrtColor), ');
    sql.Add(' m=floor(PrtRollNum / 10),n=PrtRollNum % 10, ');
    sql.Add(' RollSum=(select sum(PrtRollNum) from JYOrder_Sub X where X.mainID=A.mainID),');
    sql.Add(' QtySum=(select sum(PrtOrderQty) from JYOrder_Sub X where X.mainID=A.mainID), ');
    sql.Add(' C_CodeNameZW=(select Top 1 defnote3 from KH_Zdy_Attachment X where X.ZdyName=A.prtCodeName and Type=''CP'') ');
    sql.Add(',C_colorName=(select Top 1 DEFstr6 from KH_Zdy_Attachment X where X.ZdyName=A.prtCodeName and X.DEFstr3=A.PrtColor and Type=''CP'') ');
    sql.Add('from  JYOrder_Sub A ');
    sql.Add('inner join JYOrder_Main  B on B.mainID=A.MainID ');
    sql.Add('where A.mainID='+quotedstr(trim(Order_Main.fieldbyname('MainID').AsString)));
    Open;
  end;
  SCreateCDS20(ADOQueryPrint,CDS_Print);

  with ADOQueryPrint do
  begin
    while not eof do
    begin
      IF fieldbyname('m').AsInteger<1 then K:=1;
      IF (fieldbyname('m').AsInteger>=1) and  (fieldbyname('n').AsInteger=0) then
      k:=fieldbyname('m').AsInteger;
      IF (fieldbyname('m').AsInteger>=1) and  (fieldbyname('n').AsInteger<>0) then
      k:=fieldbyname('m').AsInteger+1;

      for i:=1 to k  do
      begin
        CDS_Print.Append;
        for j:=0 to FieldCount-1 do
        begin
          CDS_Print.fields[j].value:=Fields[j].Value;
        end;
        CDS_Print.Post;
      end;
      next;
    end;
  end;

        try
          Moudle:=LoadLibrary('MakeQRBarcode.dll');
          @Makebar:=GetProcAddress(Moudle,'Make');
          @Mixtext:=GetProcAddress(Moudle,'MixText');
          Txt:=Trim(ADOQueryPrint.fieldbyname('mainID').AsString);
          fImagePath:=ExtractFilePath(Application.ExeName)+'image\temp.bmp';
          if not DirectoryExists(pchar(ExtractFilePath(Application.ExeName)+'image')) then
          CreateDirectory(pchar(ExtractFilePath(Application.ExeName)+'image'),nil);
          if FileExists(fImagePath) then DeleteFile(fImagePath);
          Makebar(pchar(Txt),Length(Txt),3,3,0,PChar(fImagePath),3);
        except
          application.MessageBox('ʧܣ','ʾϢ',MB_ICONERROR);
          Order_Main.EnableControls;
          exit;
        end;

  if FileExists(fPrintFile) then
  begin
      RMVariables['QRBARCODE']:=fImagePath;
    RMVariables['customerNoName']:=Trim(Order_Main.fieldbyname('customerNoName').AsString);
    RMVariables['OrderNo']:=Trim(Order_Main.fieldbyname('OrderNo').AsString);
    RMVariables['Note']:=Trim(Order_Main.fieldbyname('Note').AsString);
    RMVariables['FHAddress']:=Trim(Order_Main.fieldbyname('FHAddress').AsString);
    RMVariables['LXFS']:=Trim(Order_Main.fieldbyname('LXFS').AsString);
    RMVariables['OrdDate']:=Order_Main.fieldbyname('OrdDate').Value;
    RMVariables['OrdPerson1']:=Order_Main.fieldbyname('OrdPerson1').Value;
    RM1.LoadFromFile(fPrintFile);
   // RM1.ShowReport;
   RM1.PrintReport;
  end
  else
  begin
    Application.MessageBox(PChar('û'+ExtractFilePath(Application.ExeName)+'Report\ָʾ.rmf'),'ʾ',0);
    exit;
  end;
    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add('Update JYOrder_Main Set OrdDefDate1=getdate(),OrdFlag1=1');
      sql.Add(' where MainId='''+Trim(Order_Main.fieldbyname('MainId').AsString)+'''');
      ExecSQL;
    end;
end;

procedure TfrmProductOrderNewListXH.TBRafreshClick(Sender: TObject);
begin

    InitGrid();
end;

procedure TfrmProductOrderNewListXH.TBAddClick(Sender: TObject);
var
  maxno:string;
begin
  try
    frmOrderInPut:=TfrmOrderInPut.Create(Application);
    with frmOrderInPut do
    begin
      PState:=0;
      FMainId:='';
      fCustomerNoName:=self.fCustomerNoName;
      forderType:=self.forderType;
      fsyrName:=self.fsyrName;

      if ShowModal=1 then
      begin
        TBRafresh.Click;
      end;
    end;
  finally
    frmOrderInPut.Free;
  end;


end;

procedure TfrmProductOrderNewListXH.OrderNoChange(Sender: TObject);
begin
  if ADOQueryMain.Active=False then Exit;
  SDofilter(ADOQueryMain,SGetFilters(Panel1,1,2));
  SCreateCDS20(ADOQueryMain,Order_Main);
  SInitCDSData20(ADOQueryMain,Order_Main);
end;

procedure TfrmProductOrderNewListXH.FormShow(Sender: TObject);
begin
  SetStatus();
  InitForm();
end;

procedure TfrmProductOrderNewListXH.Tv1CellDblClick(
  Sender: TcxCustomGridTableView;
  ACellViewInfo: TcxGridTableDataCellViewInfo; AButton: TMouseButton;
  AShift: TShiftState; var AHandled: Boolean);
begin
  if ToolButton1.Visible=False then Exit;
  ToolButton1.Click;
end;

procedure TfrmProductOrderNewListXH.TBTPClick(Sender: TObject);
 var
   FQty,FQty1,FMxQty,FPQty,FMxQtyS,FPQtyS:String;
begin
end;

procedure TfrmProductOrderNewListXH.CheckBox1Click(Sender: TObject);
begin
  InitGrid();
end;

procedure TfrmProductOrderNewListXH.CheckBox2Click(Sender: TObject);
begin
  TBRafresh.Click;
end;

procedure TfrmProductOrderNewListXH.Tv1StylesGetContentStyle(
  Sender: TcxCustomGridTableView; ARecord: TcxCustomGridRecord;
  AItem: TcxCustomGridTableItem; out AStyle: TcxStyle);
var
  id,id10:Integer;
begin

end;

procedure TfrmProductOrderNewListXH.v1DeliveryDateCustomDrawCell(
  Sender: TcxCustomGridTableView; ACanvas: TcxCanvas;
  AViewInfo: TcxGridTableDataCellViewInfo; var ADone: Boolean);
begin
 { Id:=TV1.GetColumnByFieldName('DeliveryDate').Index;//;-TV1.GroupedItemCount;
  Id10:=TV1.GetColumnByFieldName('SubStatus').Index;
  if Id<0 then Exit;
  if AViewInfo.GridRecord.Values[Id10]='' then Exit;
  if AViewInfo.GridRecord.Values[Id]-SGetServerDate(ADOQueryTemp)>=4 then Exit;
  if ((AViewInfo.GridRecord.Values[id]-SGetServerDate10(ADOQueryTemp))>=0) and ((AViewInfo.GridRecord.Values[id]-SGetServerDate(ADOQueryTemp))<4) then
    ACanvas.Brush.Color:=clYellow
  else
  if (AViewInfo.GridRecord.Values[id])-(SGetServerDate10(ADOQueryTemp)<0) then
  begin
    ACanvas.Brush.Color:=clRed;
  end;
  begin
    ACanvas.Brush.Color:=clRed;
  end else
  if AViewInfo.GridRecord.Values[Id]='Purple' then
  begin
    ACanvas.Brush.Color:=clPurple;
  end else
  if AViewInfo.GridRecord.Values[Id]='Olive' then
  begin
    ACanvas.Brush.Color:=clOlive;
  end else
  if AViewInfo.GridRecord.Values[Id]='Teal' then
  begin
    ACanvas.Brush.Color:=clTeal;
  end else
  if AViewInfo.GridRecord.Values[Id]='Background' then
  begin
    ACanvas.Brush.Color:=clBackground;
  end;   }
end;

procedure TfrmProductOrderNewListXH.N1Click(Sender: TObject);
var
   fPrintFile:string;
   Porderno:string;
begin
  if Order_Main.IsEmpty then Exit;
  fPrintFile:= ExtractFilePath(Application.ExeName) + 'Report\ָʾ10.rmf' ;
  SDofilter(ADOQueryMain,' OrderNoM='''+Trim(Order_Main.fieldbyname('OrderNoM').AsString)+'''');
  SCreateCDS20(ADOQueryMain,Order_Main);
  SInitCDSData20(ADOQueryMain,Order_Main);
  Porderno:=Trim(Order_Main.fieldbyname('OrderNoM').AsString);
  if FileExists(fPrintFile) then
  begin
    //RMVariables['begindate']:=begindate.DateTime;
    //RMVariables['enddate']:=enddate.DateTime;
    //RMVariables['printtime']:=Now;
    //RMVariables['printer']:=Trim(gUserName);
    RM1.LoadFromFile(fPrintFile);
    RM1.ShowReport;
  end else
  begin
    Application.MessageBox(PChar('û'+ExtractFilePath(Application.ExeName)+'Report\ָʾ10.rmf'),'ʾ',0);
  end;
  SDofilter(ADOQueryMain,'');
  SCreateCDS20(ADOQueryMain,Order_Main);
  SInitCDSData20(ADOQueryMain,Order_Main);
  Order_Main.Locate('ordernoM',Porderno,[]);
end;

procedure TfrmProductOrderNewListXH.N2Click(Sender: TObject);
var
   fPrintFile:string;
   Porderno:string;
begin
  if Order_Main.IsEmpty then Exit;
  fPrintFile:= ExtractFilePath(Application.ExeName) + 'Report\ָʾ.rmf' ;
  SDofilter(ADOQueryMain,' OrderNoM='''+Trim(Order_Main.fieldbyname('OrderNoM').AsString)+'''');
  SCreateCDS20(ADOQueryMain,Order_Main);
  SInitCDSData20(ADOQueryMain,Order_Main);
  Porderno:=Trim(Order_Main.fieldbyname('OrderNoM').AsString);
  if FileExists(fPrintFile) then
  begin
    //RMVariables['begindate']:=begindate.DateTime;
    //RMVariables['enddate']:=enddate.DateTime;
    //RMVariables['printtime']:=Now;
    //RMVariables['printer']:=Trim(gUserName);
    RM1.LoadFromFile(fPrintFile);
    RM1.ShowReport;
  end else
  begin
    Application.MessageBox(PChar('û'+ExtractFilePath(Application.ExeName)+'Report\ָʾ.rmf'),'ʾ',0);
  end;
  SDofilter(ADOQueryMain,'');
  SCreateCDS20(ADOQueryMain,Order_Main);
  SInitCDSData20(ADOQueryMain,Order_Main);
  Order_Main.Locate('ordernoM',Porderno,[]);
end;

procedure TfrmProductOrderNewListXH.ToolButton1Click(Sender: TObject);
begin
  if Order_Main.IsEmpty then Exit;
  try
    frmOrderInPut:=TfrmOrderInPut.Create(Application);
    with frmOrderInPut do
    begin
    forderType:=self.forderType;
      PState:=1;
      FMainId:=Trim(Self.Order_Main.fieldbyname('MainId').AsString);
      ToolBar2.Enabled:=False;
      TBSave.Visible:=False;
      ScrollBox1.Enabled:=False;
      Tv1.OptionsSelection.CellSelect:=False;
            fsyrName:=self.fsyrName;
      if ShowModal=1 then
      begin

      end;
    end;
  finally
    frmOrderInPut.Free;
  end;
end;

procedure TfrmProductOrderNewListXH.ToolButton2Click(Sender: TObject);
begin
  if Order_Main.IsEmpty then Exit;
  try
    frmOrderInPut:=TfrmOrderInPut.Create(Application);
    with frmOrderInPut do
    begin
    forderType:=self.forderType;
      PState:=1;
      CopyInt:=99;
      FMainId:=Trim(Self.Order_Main.fieldbyname('MainId').AsString);
            fsyrName:=self.fsyrName;
      if ShowModal=1 then
      begin

      end;
    end;
  finally
    frmOrderInPut.Free;
  end;
end;

procedure TfrmProductOrderNewListXH.ToolButton3Click(Sender: TObject);
begin
  ModalResult:=1;
end;

procedure TfrmProductOrderNewListXH.OrderNoKeyPress(Sender: TObject;
  var Key: Char);
begin
{  if Key=#13 then
  begin
    if Length(OrderNo.Text)<3 then Exit;
    try
      ADOQueryMain.DisableControls;
      with ADOQueryMain do
      begin
        Filtered:=False;
        Close;
        sql.Clear;
        sql.add('exec P_View_Order :begdate,:enddate,:WSql') ;
        if Trim(fDParameters1)<>'Ȩ'  then
        begin
          Parameters.ParamByName('WSql').Value:=' and A.Filler='''+Trim(DName)+'''';
        end;
        begin
          Parameters.ParamByName('WSql').Value:=' and orderno like '''+'%'+Trim(OrderNo.Text)+'%'+'''';
        end;
        Parameters.ParamByName('begdate').Value:='1899-01-01';
        Parameters.ParamByName('enddate').Value:='2050-01-01';
        ExecSQL;
        Open;
      end;
      SCreateCDS20(ADOQueryMain,Order_Main);
      SInitCDSData20(ADOQueryMain,Order_Main);
    finally
      ADOQueryMain.EnableControls;
    end;
  end;   }
end;

procedure TfrmProductOrderNewListXH.ConNoKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Key=#13 then
  begin
    if Length(conno.Text)<3 then Exit;
    try
      ADOQueryMain.DisableControls;
      with ADOQueryMain do
      begin
        Filtered:=False;
        Close;
        sql.Clear;
        sql.add('exec P_View_Order :begdate,:enddate,:WSql') ;
        if Trim(fDParameters1)<>'Ȩ'  then
        begin
          Parameters.ParamByName('WSql').Value:=' and A.Filler='''+Trim(DName)+'''';
        end;
        begin
          Parameters.ParamByName('WSql').Value:=' and conno like '''+'%'+Trim(conno.Text)+'%'+'''';
        end;
        Parameters.ParamByName('begdate').Value:='1899-01-01';
        Parameters.ParamByName('enddate').Value:='2050-01-01';
        ExecSQL;
        Open;
      end;
      SCreateCDS20(ADOQueryMain,Order_Main);
      SInitCDSData20(ADOQueryMain,Order_Main);
    finally
      ADOQueryMain.EnableControls;
    end;
  end;
end;

procedure TfrmProductOrderNewListXH.tchkClick(Sender: TObject);
begin
 if Order_Main.IsEmpty then exit;
  try
    with ADOQueryCmd do
    begin
      close;
      sql.Clear;
      sql.Add('update  JYOrder_main SET status=''1'' ');
      sql.Add('where mainID='+quotedstr(trim(Order_Main.fieldbyname('mainID').AsString)));
      sql.Add('insert into SY_SysLog(operor,opertime,Model,acction,opevent,result) values( ');
      sql.Add(' '+quotedstr(trim(DName)));
      sql.Add(',getdate() ');
      sql.Add(','+quotedstr(trim(self.Caption)));
      sql.Add(','+quotedstr(trim('ָʾ')));
      sql.Add(','+quotedstr(trim('ţ'+trim(Order_Main.FieldByName('orderNo').AsString))));
      sql.Add(','+quotedstr(trim('ɹ')));
      sql.Add(')');
      execsql;
    end;
    application.MessageBox('ҵ˳ɹ','ʾϢ');
    IF Order_Main.fieldbyname('orderType').AsString='' then
    begin
      if Application.MessageBox('ȷҪӡҵָʾ','ʾ',32+4)=IDYES then
      begin
        TBPrint.Click;
      end;
    end;
 {   IF fCustomerNoName<>'㶫в'then
    begin
      if Application.MessageBox('ȷҪӡҵָʾ','ʾ',32+4)=IDYES then
      begin
        IF Order_Main.fieldbyname('orderType').AsString='' then
        TBPrint1.Click
        else
        TBPrint.Click;
      end;
    end;  }
    TBRafresh.Click;
  except
   application.MessageBox('ҵʧܣ','ʾϢ',0);
  end;
end;

procedure TfrmProductOrderNewListXH.tNochkClick(Sender: TObject);
begin
  if Order_Main.IsEmpty then exit;
    with ADOQueryCmd do
    begin
      close;
      sql.Clear;
      sql.Add('select * from CK_BanCP_PH ');
      sql.Add('where mainID='+quotedstr(trim(Order_Main.fieldbyname('mainID').AsString)));
    //  sql.Add('and  isnull(substatus,'''')>''0'' ');
      open;
      if not ADOQueryCmd.IsEmpty then
      begin
        application.MessageBox('˵Ѿ ܳˣ','ʾϢ',0);
        exit;
      end;
    end;

    with ADOQueryCmd do
    begin
      close;
      sql.Clear;
      sql.Add('select * from BP_inout ');
      sql.Add('where mainID='+quotedstr(trim(Order_Main.fieldbyname('mainID').AsString)));
      sql.Add('and cRType =''Ʒ۳''');
    //  sql.Add('and  isnull(substatus,'''')>''0'' ');
      open;
      if not ADOQueryCmd.IsEmpty then
      begin
        application.MessageBox('˵ѾƷ⣬ ܳˣ','ʾϢ',0);
        exit;
      end;
    end;

  try
    with ADOQueryCmd do
    begin
      close;
      sql.Clear;
      sql.Add('update  JYOrder_main SET status=''0'' ');
      sql.Add('where mainID='+quotedstr(trim(Order_Main.fieldbyname('mainID').AsString)));
      
      sql.Add('insert into SY_SysLog(operor,opertime,Model,acction,opevent,result) values( ');
      sql.Add(' '+quotedstr(trim(DName)));
      sql.Add(',getdate() ');
      sql.Add(','+quotedstr(trim(self.Caption)));
      sql.Add(','+quotedstr(trim('ָʾ')));
      sql.Add(','+quotedstr(trim('ţ'+trim(Order_Main.FieldByName('orderNo').AsString))));
      sql.Add(','+quotedstr(trim('ɹ')));
      sql.Add(')');
      execsql;
    end;
    application.MessageBox('˳ɹ','ʾϢ');
    TBRafresh.Click;
  except
   application.MessageBox('˳ʧܣ','ʾϢ',0);
  end;
end;

procedure TfrmProductOrderNewListXH.cxTabControl1Change(Sender: TObject);
begin
  SetStatus();


  application.ProcessMessages;
  initGrid();
end;

procedure TfrmProductOrderNewListXH.TBPrint1Click(Sender: TObject);
var
   fPrintFile:string;
   Porderno,PRTCodeName,funit:string;
   i,j:Integer;
   Txt,fImagePath:string;
   Moudle: THandle;
   Makebar:TMakebar;
   Mixtext:TMixtext;
begin
  if Order_Main.IsEmpty then Exit;
   fPrintFile:= ExtractFilePath(Application.ExeName) + 'Report\ָʾ.rmf' ;

  with ADOQueryPrint do
  begin
    Close;
    sql.Clear;
    sql.Add('select *, ');
    sql.Add(' RollSum=(select sum(PrtRollNum) from JYOrder_Sub X where X.mainID=A.mainID),');
    sql.Add(' QtySum=(select sum(PrtOrderQty) from JYOrder_Sub X where X.mainID=A.mainID), ');
    sql.Add(' C_CodeNameZW=(select Top 1 defnote3 from KH_Zdy_Attachment X where X.ZdyName=A.prtCodeName and Type=''CP'') ');
    sql.Add(',C_colorName=(select Top 1 DEFstr6 from KH_Zdy_Attachment X where X.ZdyName=A.prtCodeName and X.DEFstr3=A.PrtColor and Type=''CP'') ');
    sql.Add('from  JYOrder_Sub A ');
    sql.Add('inner join JYOrder_Main  B on B.mainID=A.MainID ');
    sql.Add('where A.mainID='+quotedstr(trim(Order_Main.fieldbyname('MainID').AsString)));
    Open;
  end;
  SCreateCDS20(ADOQueryPrint,CDS_Print);
  SInitCDSData20(ADOQueryPrint,CDS_Print);
        try
          Moudle:=LoadLibrary('MakeQRBarcode.dll');
          @Makebar:=GetProcAddress(Moudle,'Make');
          @Mixtext:=GetProcAddress(Moudle,'MixText');
          Txt:=Trim(ADOQueryPrint.fieldbyname('mainID').AsString);
          fImagePath:=ExtractFilePath(Application.ExeName)+'image\temp.bmp';
          if not DirectoryExists(pchar(ExtractFilePath(Application.ExeName)+'image')) then
          CreateDirectory(pchar(ExtractFilePath(Application.ExeName)+'image'),nil);
          if FileExists(fImagePath) then DeleteFile(fImagePath);
          Makebar(pchar(Txt),Length(Txt),3,3,0,PChar(fImagePath),3);
        except
          application.MessageBox('ʧܣ','ʾϢ',MB_ICONERROR);
          Order_Main.EnableControls;
          exit;
        end;



  if FileExists(fPrintFile) then
  begin
      RMVariables['QRBARCODE']:=fImagePath;
    RMVariables['customerNoName']:=Trim(Order_Main.fieldbyname('customerNoName').AsString);
    RMVariables['OrderNo']:=Trim(Order_Main.fieldbyname('OrderNo').AsString);
    RMVariables['Note']:=Trim(Order_Main.fieldbyname('Note').AsString);
    RMVariables['FHAddress']:=Trim(Order_Main.fieldbyname('FHAddress').AsString);
    RMVariables['LXFS']:=Trim(Order_Main.fieldbyname('LXFS').AsString);
    RMVariables['OrdDate']:=Order_Main.fieldbyname('OrdDate').Value;
    RMVariables['OrdPerson1']:=Order_Main.fieldbyname('OrdPerson1').Value;
    RM1.LoadFromFile(fPrintFile);
    RM1.ShowReport;
  end else
  begin
    Application.MessageBox(PChar('û'+ExtractFilePath(Application.ExeName)+'Report\ָʾ.rmf'),'ʾ',0);
    exit;
  end;
    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add('Update JYOrder_Main Set OrdDefDate1=getdate(),OrdFlag1=1');
      sql.Add(' where MainId='''+Trim(Order_Main.fieldbyname('MainId').AsString)+'''');
      ExecSQL;
    end;
end;


procedure TfrmProductOrderNewListXH.Tv1CustomDrawCell(
  Sender: TcxCustomGridTableView; ACanvas: TcxCanvas;
  AViewInfo: TcxGridTableDataCellViewInfo; var ADone: Boolean);
begin
  IF  AViewInfo.GridRecord.Values[tv1.GetColumnByFieldName('OrdFlag1').Index]=0 then
  begin
    ACanvas.Brush.Color:=clSkyBlue;
  end;
end;

procedure TfrmProductOrderNewListXH.TBPrint2Click(Sender: TObject);
var
   fPrintFile:string;
   Porderno,PRTCodeName,funit:string;
   i,j:Integer;
   Txt,fImagePath:string;
   Moudle: THandle;
   Makebar:TMakebar;
   Mixtext:TMixtext;
begin
  if Order_Main.IsEmpty then Exit;
   fPrintFile:= ExtractFilePath(Application.ExeName) + 'Report\ָʾֽ.rmf' ;

  with ADOQueryPrint do
  begin
    Close;
    sql.Clear;
    sql.Add('select *, ');
    sql.Add(' RollSum=(select sum(PrtRollNum) from JYOrder_Sub X where X.mainID=A.mainID),');
    sql.Add(' QtySum=(select sum(PrtOrderQty) from JYOrder_Sub X where X.mainID=A.mainID), ');
    sql.Add(' KCNUm=(select sum(kcRollNum) from CK_BanCP_KC X where X.C_CodeName=A.prtCodeName and x.KCQty>0 and X.C_Color = A.PrtColor AND x.CPType not in(''һȴƷ'',''ȴƷ'')), ');
    sql.Add(' CPKW=(select Top 1 zdyCode from KH_Zdy_Attachment X where X.DEFstr1=A.prtCodeName and X.DEFstr2=A.PrtColor)');
    sql.Add(' C_CodeNameZW=(select Top 1 defnote3 from KH_Zdy_Attachment X where X.ZdyName=A.prtCodeName and Type=''CP''), ');
    sql.Add(',C_colorName=(select Top 1 DEFstr6 from KH_Zdy_Attachment X where X.ZdyName=A.prtCodeName and X.DEFstr3=A.PrtColor and Type=''CP'') ');
    sql.Add('from  JYOrder_Sub A ');
    sql.Add('inner join JYOrder_Main  B on B.mainID=A.MainID ');
    sql.Add('where A.mainID='+quotedstr(trim(Order_Main.fieldbyname('MainID').AsString)));
    Open;
  end;
  SCreateCDS20(ADOQueryPrint,CDS_Print);
  SInitCDSData20(ADOQueryPrint,CDS_Print);

        try
          Moudle:=LoadLibrary('MakeQRBarcode.dll');
          @Makebar:=GetProcAddress(Moudle,'Make');
          @Mixtext:=GetProcAddress(Moudle,'MixText');
          Txt:=Trim(ADOQueryPrint.fieldbyname('mainID').AsString);
          fImagePath:=ExtractFilePath(Application.ExeName)+'image\temp.bmp';
          if not DirectoryExists(pchar(ExtractFilePath(Application.ExeName)+'image')) then
          CreateDirectory(pchar(ExtractFilePath(Application.ExeName)+'image'),nil);
          if FileExists(fImagePath) then DeleteFile(fImagePath);
          Makebar(pchar(Txt),Length(Txt),3,3,0,PChar(fImagePath),3);
        except
          application.MessageBox('ʧܣ','ʾϢ',MB_ICONERROR);
          Order_Main.EnableControls;
          exit;
        end;



  if FileExists(fPrintFile) then
  begin
    RMVariables['QRBARCODE']:=fImagePath;
    RMVariables['customerNoName']:=Trim(Order_Main.fieldbyname('customerNoName').AsString);
    RMVariables['OrderNo']:=Trim(Order_Main.fieldbyname('OrderNo').AsString);
    RMVariables['Note']:=Trim(Order_Main.fieldbyname('Note').AsString);
    RMVariables['FHAddress']:=Trim(Order_Main.fieldbyname('FHAddress').AsString);
    RMVariables['LXFS']:=Trim(Order_Main.fieldbyname('LXFS').AsString);
    RMVariables['OrdDate']:=Order_Main.fieldbyname('OrdDate').Value;
    RMVariables['OrdPerson1']:=Order_Main.fieldbyname('OrdPerson1').Value;
    RM1.LoadFromFile(fPrintFile);
    RM1.ShowReport;
  end else
  begin
    Application.MessageBox(PChar('û'+ExtractFilePath(Application.ExeName)+'Report\ָʾֽ.rmf'),'ʾ',0);
    exit;
  end;
  with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add('Update JYOrder_Main Set OrdDefDate1=getdate(),OrdFlag1=1');
    sql.Add(' where MainId='''+Trim(Order_Main.fieldbyname('MainId').AsString)+'''');
    ExecSQL;
  end;
end;

procedure TfrmProductOrderNewListXH.Button1Click(Sender: TObject);
var
  str:string;
begin
 if Order_Main.IsEmpty then Exit;

 if trim(cust.Text)='' then
 begin
   application.MessageBox('ͻΪգ','ʾϢ',0);
   Exit;
 end;
{ with ADOQueryTemp do
 begin
   close;
   sql.Clear;
   sql.Add('select * from YF_Money_CR A where A.MainId='''+Trim(Order_Main.fieldbyname('MainId').AsString)+''' and A.status>''0'' ');
   open;
 end;
 IF not ADOQueryTemp.IsEmpty then
 begin
   application.MessageBox('Ӧտδˣ޸ģ','ʾϢ',MB_ICONERROR);
   exit;
 end;  }
 str:= 'ţ'+trim(Order_Main.FieldByName('orderNo').AsString)+'  ͻ'+trim(Order_Main.FieldByName('customerNoName').AsString)+'->'+trim(cust.Text);

  try
    ADOQueryCmd.Connection.BeginTrans;
    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add('update JYOrder_Main SET customerNO='''+trim(cust.TxtCode)+''', customerNOName='''+trim(cust.Text)+''' where MainId='''+Trim(Order_Main.fieldbyname('MainId').AsString)+'''');
      sql.Add('update YF_Money_CR  SET factoryName='''+trim(cust.Text)+''', comtaiTou='''+trim(cust.Text)+''' where MainId='''+Trim(Order_Main.fieldbyname('MainId').AsString)+'''');
      sql.Add('insert into SY_SysLog(operor,opertime,Model,acction,opevent,result) values( ');
      sql.Add(' '+quotedstr(trim(DName)));
      sql.Add(',getdate() ');
      sql.Add(','+quotedstr(trim(self.Caption)));
      sql.Add(','+quotedstr(trim('ָʾͻ')));
      sql.Add(','+quotedstr(trim(str)));
      sql.Add(','+quotedstr(trim('ɹ')));
      sql.Add(')');
      ExecSQL;
    end;
    ADOQueryCmd.Connection.CommitTrans;
    Panel2.Visible:=false;
    initgrid();
  except
    ADOQueryCmd.Connection.RollbackTrans;
    Application.MessageBox('޸쳣','ʾ',0);
  end;
end;

procedure TfrmProductOrderNewListXH.Button3Click(Sender: TObject);
var
  str1:string;
begin
  IF CDSPrice.IsEmpty then exit;
  cust.SetFocus;
{  with ADOQueryTemp do
  begin
   close;
   sql.Clear;
   sql.Add('select * from YF_Money_CR A where A.MainId='''+Trim(Order_Main.fieldbyname('MainId').AsString)+''' and A.status>''0'' ');
   open;
  end;
  IF not ADOQueryTemp.IsEmpty then
  begin
   application.MessageBox('Ӧտδˣ޸ģ','ʾϢ',MB_ICONERROR);
   exit;
  end; }
  if Application.MessageBox('ȷҪ޸ĵ','ʾ',32+4)<>IDYES then Exit;
  try
    ADOQueryCmd.Connection.BeginTrans;
    CDSPrice.First;
    while not CDSPrice.Eof do
    begin
      with ADOQueryTemp do
      begin
        close;
        sql.Clear;
        sql.Add('select PRTPrice FROM JYOrder_sub X where subID='''+Trim(CDSPrice.fieldbyname('subID').AsString)+'''');
        open;
      end;
      IF ADOQueryTemp.fieldbyname('PrtPrice').AsFloat<>CDSPrice.FieldByName('PrtPrice').AsFloat then
      begin
        str1:=trim(CDSPrice.fieldbyname('subID').AsString)+':'+ADOQueryTemp.fieldbyname('PrtPrice').AsString+'->'+CDSPrice.FieldByName('PrtPrice').AsString;
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('update JYOrder_sub SET PRTPrice='''+trim(CDSPrice.fieldbyname('PRTPrice').AsString)+''' where MainID='''+Trim(CDSPrice.fieldbyname('MainId').AsString)+''' and subID='''+Trim(CDSPrice.fieldbyname('subID').AsString)+''' ');
          sql.Add('update YF_Money_CR SET Price='''+trim(CDSPrice.fieldbyname('PRTPrice').AsString)+''' where MainID='''+Trim(CDSPrice.fieldbyname('MainId').AsString)+''' and subID='''+Trim(CDSPrice.fieldbyname('subID').AsString)+''' ');
          sql.Add('update YF_Money_CR SET Money=Price*Qty,BBMoney=Price*Qty*HuiLv where MainID='''+Trim(CDSPrice.fieldbyname('MainId').AsString)+''' and subID='''+Trim(CDSPrice.fieldbyname('subID').AsString)+''' ');
          sql.Add('insert into SY_SysLog(operor,opertime,Model,acction,opevent,result) values( ');
          sql.Add(' '+quotedstr(trim(DName)));
          sql.Add(',getdate() ');
          sql.Add(','+quotedstr(trim(self.Caption)));
          sql.Add(','+quotedstr(trim('ָʾ۸')));
          sql.Add(','+quotedstr(trim(str1)));
          sql.Add(','+quotedstr(trim('ɹ')));
          sql.Add(')');
          ExecSQL;
        end;
      end;
      CDSPrice.Next;
    end;
    ADOQueryCmd.Connection.CommitTrans;
    Panel2.Visible:=false;
    //initgrid();
  except
    ADOQueryCmd.Connection.RollbackTrans;
    Application.MessageBox('޸쳣','ʾ',0);
  end;
end;

procedure TfrmProductOrderNewListXH.TBcustClick(Sender: TObject);
begin
  IF order_main.IsEmpty then exit;
//  CDSPrice.EmptyDataSet;
  with ADOQueryTemp DO
  begin
    close;
    sql.Clear;
    sql.Add('select * from JYOrder_sub X where MainID='+quotedstr(trim(order_main.fieldbyname('MainID').AsString)));
    open;
  end;
  SCreateCDS20(ADOQueryTemp,CDSPrice);
  SInitCDSData20(ADOQueryTemp,CDSPrice);
  cust.Text:='';
  cust.TxtCode:='';
  Panel2.Left:=(self.Width- Panel2.Width) div 2;
  Panel2.Visible:=true;
end;

procedure TfrmProductOrderNewListXH.custBtnClick(Sender: TObject);
begin
 try
    frmZdyAttachment:=TfrmZdyAttachment.Create(Application);
    with frmZdyAttachment do
    begin
      fkhType:='';
      fkhType:=self.fsyrName;
      if ShowModal=1 then
      begin
        cust.Text:=Trim(CDS_HZ.fieldbyname('ZDYName').AsString);
        cust.TxtCode:=Trim(CDS_HZ.fieldbyname('ZdyCode').AsString);
      end;
  end;
  finally
    frmZdyAttachment.Free;
  end;
end;

procedure TfrmProductOrderNewListXH.TrzClick(Sender: TObject);
begin
  frmSysLogHelp:=TfrmSysLogHelp.create(self);
  with frmSysLogHelp do
  begin
    facction:='ָʾɾ';
    showmodal;
    free;
  end;
end;

procedure TfrmProductOrderNewListXH.Button2Click(Sender: TObject);
begin
  Panel2.Visible:=false;
end;

procedure TfrmProductOrderNewListXH.ToolButton4Click(Sender: TObject);
var
  filepath,fOrderNo:string;
  i:integer;
  Txt,fImagePath:string;
  Moudle: THandle;
  Makebar:TMakebar;
  Mixtext:TMixtext;
begin
  if Order_Main.IsEmpty then exit;

  IF Order_Main.FieldByName('OrderType').AsString='' then
  begin
    with AdoPrint do
    begin
    close;
    sql.Clear;
    sql.Add('select A.mainID,A.subID,A.SYRName,A.cust,A.P_CodeName,A.P_Color,A.QtyUnit,B.Sorddefnote1,c.note,C.orderNo,C.customerNoname,C.orddefnote1,C.FHAddress,C.LXFS,C.Filler as xsyg,SUM(A.Qty) as Qty,AVG(A.Price) as Price,SUM(A.money) as Money,  ');
    sql.Add('customNameAddress=(select Top 1 DEFNote1 from KH_Zdy_Attachment X where X.ZdyName=A.cust),  ');
    sql.Add('DEFNote2=(select Top 1 DEFNote2 from KH_Zdy_Attachment X where X.ZdyName=A.cust),      ');
    sql.Add('defstr8=(select Top 1 defstr8 from KH_Zdy_Attachment X where X.ZdyName=A.cust),        ');
    sql.Add('defstr2=(select Top 1 defstr2 from KH_Zdy_Attachment X where X.ZdyName=A.cust),');
    sql.Add('DEFNote3=(select Top 1 DEFNote3 from KH_Zdy_Attachment X where X.ZdyName=A.cust),    ');
    sql.Add('P_CodeNameZW=(select Top 1 defnote3 from KH_Zdy_Attachment X where X.ZdyName=A.P_CodeName and Type=''CP'') ');
    sql.Add(',P_colorName=(select Top 1 DEFstr6 from KH_Zdy_Attachment X where X.ZdyName=A.P_CodeName and X.DEFstr3=A.P_Color and Type=''CP'') ');
    sql.Add('from BP_INout A                   ');
    sql.Add('left join JYOrder_sub B on B.mainID=A.mainID and B.subID=A.subID ');
    sql.Add('left join JYOrder_Main C on C.mainID=A.mainID ');
    sql.Add('where A.MainID='+quotedstr(trim(Order_Main.fieldbyname('mainID').AsString)));
    sql.Add('group by  A.mainID,A.subID,A.SYRName,A.cust,A.P_CodeName,A.P_Color,A.QtyUnit,B.Sorddefnote1,c.note,C.orderNo,C.customerNoname,C.orddefnote1,C.FHAddress,C.LXFS,C.Filler');
    open;
    end;
    filepath:=ExtractFilePath(Application.ExeName) + 'report\뵥Ʒ.rmf';

    if not FileExists(Pchar(filepath))  then
    begin
      application.MessageBox(pchar('ļ['+filepath+']ڣ'),'ʾϢ',MB_IConError);
      exit;
    end;
        try
          Moudle:=LoadLibrary('MakeQRBarcode.dll');
          @Makebar:=GetProcAddress(Moudle,'Make');
          @Mixtext:=GetProcAddress(Moudle,'MixText');
          Txt:=Trim(AdoPrint.fieldbyname('orderNo').AsString);
          fImagePath:=ExtractFilePath(Application.ExeName)+'image\temp.bmp';
          if not DirectoryExists(pchar(ExtractFilePath(Application.ExeName)+'image')) then
          CreateDirectory(pchar(ExtractFilePath(Application.ExeName)+'image'),nil);
          if FileExists(fImagePath) then DeleteFile(fImagePath);
          Makebar(pchar(Txt),Length(Txt),3,3,0,PChar(fImagePath),3);
        except
          application.MessageBox('ʧܣ','ʾϢ',MB_ICONERROR);
          exit;
        end;
    RMVariables['QRBARCODE']:=fImagePath;
    RMVariables['dtxz'] :=FormatDateTime('yyyy-mm-dd',date());
    RMVariables['zdr'] :=trim(DName);
    RMVariables['Filler'] :=trim(Order_Main.fieldbyname('Filler').AsString);
    RM1.LoadFromFile(filepath);
    RM1.ShowReport;
  end
  else
  begin
    with AdoPrint do
    begin
    close;
    sql.Clear;
    sql.Add('exec P_Do_PrintMd10 ');
    sql.Add('@mainID='+quotedstr(trim(Order_Main.fieldbyname('maiNID').AsString)));
    sql.Add(',@TblCprk='+quotedstr(trim(fSYRName)));
    sql.Add(',@flag='+quotedstr(trim('뵥')));
    open;
    end;

    filepath:=ExtractFilePath(Application.ExeName) + 'report\뵥.rmf';
    if not FileExists(Pchar(filepath))  then
    begin
      application.MessageBox(pchar('ļ['+filepath+']ڣ'),'ʾϢ',MB_IConError);
      exit;
    end;
        try
          Moudle:=LoadLibrary('MakeQRBarcode.dll');
          @Makebar:=GetProcAddress(Moudle,'Make');
          @Mixtext:=GetProcAddress(Moudle,'MixText');
          Txt:=Trim(AdoPrint.fieldbyname('orderNo').AsString);
          fImagePath:=ExtractFilePath(Application.ExeName)+'image\temp.bmp';
          if not DirectoryExists(pchar(ExtractFilePath(Application.ExeName)+'image')) then
          CreateDirectory(pchar(ExtractFilePath(Application.ExeName)+'image'),nil);
          if FileExists(fImagePath) then DeleteFile(fImagePath);
          Makebar(pchar(Txt),Length(Txt),3,3,0,PChar(fImagePath),3);
        except
          application.MessageBox('ʧܣ','ʾϢ',MB_ICONERROR);
          exit;
        end;
    RMVariables['QRBARCODE']:=fImagePath;
    RMVariables['dtxz'] :=FormatDateTime('yyyy-mm-dd',date());
    RMVariables['zdr'] :=trim(DName);
    RMVariables['Filler'] :=trim(Order_Main.fieldbyname('Filler').AsString);
    RM1.LoadFromFile(filepath);
    RM1.ShowReport;
  end;

end;



end.
